searchNodes=[{"doc":"Start a Skitter master node This task starts a Skitter master node. It accepts a single option ( --deploy ) and multiple arguments, which represent worker nodes to connect to. In order to connect to the specified workers, additional arguments need to be passed to the elixir or iex command used to start the system. More information can be found in the &quot;Distribution Parameters&quot; section below. It is not recommended to use this task in production. Consider building a release (as described on the deployment page ) instead. If mix is used anyway, be sure to start in production mode. Options and Arguments --deploy , -d : Deploy the workflow returned by the expression. Besides the --deploy option, any other argument is interpreted as the name of a worker node. The master node will attempt to connect to all the specified nodes when it is starting. If this fails, the master exits. Distribution Parameters In order to connect with other Skitter nodes, the local node needs to be distributed. This task does not handle distribution, instead, the correct parameters should be passed to iex or elixir . A few examples are provided below: elixir --sname master -S mix skitter.master iex --sname master -S mix skitter.master . elixir --name master@hostname -S mix skitter.master iex --name master@hostname -S mix skitter.master .","ref":"Mix.Tasks.Skitter.Master.html","title":"Mix.Tasks.Skitter.Master","type":"task"},{"doc":"Create a Skitter project. It expects the path of the project as an argument. $ mix skitter.new PATH [--module MODULE] [--no-fetch-deps] [--fetch-deps] [--develop] This task creates a new Skitter project, similar to mix new and mix phx.new . The project is created at PATH and is set up to allow the use of Skitter. Specifically, the generated project will contain the following files: a mix.exs file which declares Skitter as a dependency and which is set up to build a Skitter release. a config/config.exs file which provides some initial configuration for Skitter and the logger. a .formatter.exs file which sets up mix format a lib/MODULE.ex file which contain an empty workflow to get started. a README.md file which documents the project layout. a .gitignore file. After setting up the project file, this task will fetch the project dependencies if required. Flags and arguments --develop : use the latest development version of Skitter (from github) instead of the current stable version (from hex.pm). --module MODULE : specify the name of the generated module. If this is not provided, a name is generated based on PATH. --(no-)deps : By default, the installer asks the user if it should run mix deps.get and mix deps.compile after creating the project. Set this flag to skip this prompt and to explicitly opt in or out of automatically running these commands.","ref":"Mix.Tasks.Skitter.New.html","title":"Mix.Tasks.Skitter.New","type":"task"},{"doc":"Start a Skitter worker node This task starts a Skitter worker node. It accepts a single argument which represents the master the worker will try to connect to and several options. In order to be able to connect to the specified master (and other workers), additional arguments need to be passed to the elixir or iex command used to start the system. More information can be found in the &quot;Distribution Parameters&quot; section below. It is not recommended to use this task in production. Consider using the skitter.release task to build a release instead. If mix is used anyway, be sure to start in production mode. Flags and Arguments --no-shutdown-with-master : By default, a worker node shuts itself down when its connected master node disconnects. This option can be passed to override this behaviour. --tag or -t : Specify a t:Skitter.Nodes.tag/0 for this worker node. This option can be used multiple times. Besides this, the name of a master node can be passed as an argument. The worker will attempt to connect to the specified master. If this is not successful, a warning is logged, however, the worker will not shut down. Distribution Parameters In order to connect with other Skitter nodes, the local node needs to be distributed. This task does not handle distrbution, instead, the correct parameters should be passed to iex or elixir . A few examples are provided below: elixir --sname worker -S mix skitter.worker iex --sname worker -S mix skitter.worker . elixir --name worker@hostname -S mix skitter.worker iex --name worker@hostname -S mix skitter.worker .","ref":"Mix.Tasks.Skitter.Worker.html","title":"Mix.Tasks.Skitter.Worker","type":"task"},{"doc":"Skitter entry point. This module serves a single point which can be used to access the features a typical user is expected to use. Concretly, this module offers access to both the Skitter runtime system and to the DSLs defined by Skitter. The runtime system can be accessed through deploy/1 and stop/1 , which are shorthands for Skitter.Runtime.deploy/1 and Skitter.Runtime.stop/1 , respectively. The DSLs can be access by adding use Skitter to the top of a file or module, which serves as a shorthand for adding use Skitter.DSL . For additional information, please refer to the documentation of Skitter.Runtime and Skitter.DSL .","ref":"Skitter.html","title":"Skitter","type":"module"},{"doc":"See Skitter.Runtime.deploy/1 .","ref":"Skitter.html#deploy/1","title":"Skitter.deploy/1","type":"function"},{"doc":"See Skitter.Runtime.stop/1 .","ref":"Skitter.html#stop/1","title":"Skitter.stop/1","type":"function"},{"doc":"Operation type definition and utilities. An operation is a reusable data processing step that can be embedded inside of a workflow. It is defined as the combination of a set of callbacks, which implement the logic of the operation, and some metadata, which define how the operation is embedded inside a workflow and how it is distributed over the cluster at runtime. A skitter operation is defined as an elixir module which implements the Skitter.Operation behaviour. This behaviour defines various elixir callbacks which are used to track operation information such as the defined callbacks. Instead of implementing an operation as an elixir module, it is recommend to use Skitter.DSL.Operation.defoperation/3 , which automatically generates the appropriate callbacks. This module defines the operation type and behaviour along with utilities to handle operations. Callbacks An operation defines various callbacks : functions which implement the data processing logic of an operation. These callbacks need to have the ability to modify state and emit data when they are called. Callbacks are implemented as elixir functions with a few properties: Callbacks accept state/0 and config/0 as their first and second arguments. Callbacks return a result/0 struct, which wraps the result of the callback call along with the updated state and emitted data. Besides this, callbacks track additional information about whether they access or modify state and which data they emit. This information is stored inside the behaviour callbacks defined in this module. Examples Since operations need to be defined in a module the example code shown in this module's documentation assumes the following module is defined: defmodule OperationModule do @behaviour Skitter.Operation alias Skitter.Operation.Callback . { Info , Result } def _sk_operation_info ( :strategy ) , do : Strategy def _sk_operation_info ( :in_ports ) , do : [ :input ] def _sk_operation_info ( :out_ports ) , do : [ :output ] def _sk_operation_initial_state , do : 42 def _sk_callbacks , do : MapSet . new ( example : 1 ) def _sk_callback_info ( :example , 1 ) do % Info { read? : true , write? : false , emit? : true } end def example ( state , config , arg ) do result = state * config % Result { state : state , emit : [ arg : arg ] , result : result } end end","ref":"Skitter.Operation.html","title":"Skitter.Operation","type":"behaviour"},{"doc":"Return the callback information of callback name , arity .","ref":"Skitter.Operation.html#c:_sk_callback_info/2","title":"Skitter.Operation._sk_callback_info/2","type":"callback"},{"doc":"Return the names and arities of all the callbacks defined in this module.","ref":"Skitter.Operation.html#c:_sk_callbacks/0","title":"Skitter.Operation._sk_callbacks/0","type":"callback"},{"doc":"Returns the meta-information of the operation. The following information is stored: :in_ports : A list of port names which represents in ports through which the operation receives incoming data. :out_ports : A list of out ports names which represents the out ports the operation can use to emit data. :strategy : The Skitter.Strategy of the operation. nil may be provided instead, in which case a strategy must be provided when the operation is embedded in a workflow.","ref":"Skitter.Operation.html#c:_sk_operation_info/1","title":"Skitter.Operation._sk_operation_info/1","type":"callback"},{"doc":"Returns the initial state of the operation. This function returns an initial state for the operation. The state of an operation is operation specific: Skitter places no constraints on this state.","ref":"Skitter.Operation.html#c:_sk_operation_initial_state/0","title":"Skitter.Operation._sk_operation_initial_state/0","type":"callback"},{"doc":"Obtain the arity of operation . The arity is defined as the amount of in ports the operation defines. Examples iex&gt; arity ( OperationModule ) 1","ref":"Skitter.Operation.html#arity/1","title":"Skitter.Operation.arity/1","type":"function"},{"doc":"Call callback callback_name with an empty state and config and arguments. This function calls Skitter.Operation.call/5 with the state created by initial_state/1 . nil is used as the value for config , no arguments are passed.","ref":"Skitter.Operation.html#call/2","title":"Skitter.Operation.call/2","type":"function"},{"doc":"Call callback callback_name with an empty state and config and arguments . This function calls Skitter.Operation.call/5 with the state created by initial_state/1 . nil is used as the value for config .","ref":"Skitter.Operation.html#call/3","title":"Skitter.Operation.call/3","type":"function"},{"doc":"Call callback callback_name with an empty state, config and arguments . This function calls Skitter.Operation.call/5 with the state created by initial_state/1 . Examples iex&gt; call ( OperationModule , :example , 2 , [ :foo ] ) % Skitter.Operation.Callback.Result { state : 42 , result : 84 , emit : [ arg : :foo ] }","ref":"Skitter.Operation.html#call/4","title":"Skitter.Operation.call/4","type":"function"},{"doc":"Call callback callback_name with state , config and arguments . Examples iex&gt; call ( OperationModule , :example , 10 , 2 , [ :foo ] ) % Skitter.Operation.Callback.Result { state : 10 , result : 20 , emit : [ arg : :foo ] }","ref":"Skitter.Operation.html#call/5","title":"Skitter.Operation.call/5","type":"function"},{"doc":"Call callback_name defined by operation if it exists. Like call_if_exists/5 , but state is replaced by the initial state of the operation, config is nil and args is the empty list.","ref":"Skitter.Operation.html#call_if_exists/2","title":"Skitter.Operation.call_if_exists/2","type":"function"},{"doc":"Call callback_name defined by operation if it exists. Like call_if_exists/5 , but state is replaced by the initial state of the operation and config is nil .","ref":"Skitter.Operation.html#call_if_exists/3","title":"Skitter.Operation.call_if_exists/3","type":"function"},{"doc":"Call callback_name defined by operation if it exists. Like call_if_exists/5 , but state is replaced by the initial state of the operation.","ref":"Skitter.Operation.html#call_if_exists/4","title":"Skitter.Operation.call_if_exists/4","type":"function"},{"doc":"Call callback_name defined by operation if it exists. Calls the callback with the given name with state , config and args if {name, length(args)} exists. If the callback does not exist, a result with the initial_state/1 of the operation, an empty emit list and nil as result is returned. Examples iex&gt; call_if_exists ( OperationModule , :example , 10 , 2 , [ :foo ] ) % Skitter.Operation.Callback.Result { state : 10 , result : 20 , emit : [ arg : :foo ] } iex&gt; call_if_exists ( OperationModule , :example , 10 , 2 , [ :foo , :bar ] ) % Skitter.Operation.Callback.Result { state : 42 , result : nil , emit : [ ] }","ref":"Skitter.Operation.html#call_if_exists/5","title":"Skitter.Operation.call_if_exists/5","type":"function"},{"doc":"Check if operation defines a callback with name and arity . Examples iex&gt; callback_exists?(OperationModule, :example, 1) true iex&gt; callback_exists?(OperationModule, :example, 2) false","ref":"Skitter.Operation.html#callback_exists?/3","title":"Skitter.Operation.callback_exists?/3","type":"function"},{"doc":"Obtain the callback information for callback name , arity in operation . Examples iex&gt; callback_info ( OperationModule , :example , 1 ) % Info { read? : true , write? : false , emit? : true }","ref":"Skitter.Operation.html#callback_info/3","title":"Skitter.Operation.callback_info/3","type":"function"},{"doc":"Obtain the set of all callbacks defined in operation . Examples iex&gt; callbacks(OperationModule) MapSet.new([example: 1])","ref":"Skitter.Operation.html#callbacks/1","title":"Skitter.Operation.callbacks/1","type":"function"},{"doc":"Get the index of an in port. Examples iex&gt; in_port_to_index ( OperationModule , :input ) 0 iex&gt; in_port_to_index ( OperationModule , :other ) nil","ref":"Skitter.Operation.html#in_port_to_index/2","title":"Skitter.Operation.in_port_to_index/2","type":"function"},{"doc":"Obtain the list of in ports of operation . Examples iex&gt; in_ports ( OperationModule ) [ :input ]","ref":"Skitter.Operation.html#in_ports/1","title":"Skitter.Operation.in_ports/1","type":"function"},{"doc":"Convert an index of an in port to a port name. Examples iex&gt; index_to_in_port ( OperationModule , 0 ) :input iex&gt; index_to_in_port ( OperationModule , 1 ) nil","ref":"Skitter.Operation.html#index_to_in_port/2","title":"Skitter.Operation.index_to_in_port/2","type":"function"},{"doc":"Convert an index of an out port to a port name. Examples iex&gt; index_to_out_port ( OperationModule , 0 ) :output iex&gt; index_to_out_port ( OperationModule , 1 ) nil","ref":"Skitter.Operation.html#index_to_out_port/2","title":"Skitter.Operation.index_to_out_port/2","type":"function"},{"doc":"Create the initial state for operation . Examples iex&gt; initial_state ( OperationModule ) 42","ref":"Skitter.Operation.html#initial_state/1","title":"Skitter.Operation.initial_state/1","type":"function"},{"doc":"Check if a given value refers to an operation module. Examples iex&gt; operation? ( 5 ) false iex&gt; operation? ( String ) false iex&gt; operation? ( OperationModule ) true","ref":"Skitter.Operation.html#operation?/1","title":"Skitter.Operation.operation?/1","type":"function"},{"doc":"Get the index of an out port. Examples iex&gt; out_port_to_index ( OperationModule , :output ) 0 iex&gt; out_port_to_index ( OperationModule , :other ) nil","ref":"Skitter.Operation.html#out_port_to_index/2","title":"Skitter.Operation.out_port_to_index/2","type":"function"},{"doc":"Obtain the list of out ports of operation . Examples iex&gt; out_ports ( OperationModule ) [ :output ]","ref":"Skitter.Operation.html#out_ports/1","title":"Skitter.Operation.out_ports/1","type":"function"},{"doc":"Check if an operation is a sink. An operation is a sink if it does not have any out ports. Examples iex&gt; sink? ( OperationModule ) false","ref":"Skitter.Operation.html#sink?/1","title":"Skitter.Operation.sink?/1","type":"function"},{"doc":"Check if an operation is a source. An operation is a source if it does not have any in ports. Examples iex&gt; source? ( OperationModule ) false","ref":"Skitter.Operation.html#source?/1","title":"Skitter.Operation.source?/1","type":"function"},{"doc":"Obtain the default strategy of operation . Examples iex&gt; strategy ( OperationModule ) Strategy","ref":"Skitter.Operation.html#strategy/1","title":"Skitter.Operation.strategy/1","type":"function"},{"doc":"Arguments passed to a callback when it is called. The arguments are wrapped in a list.","ref":"Skitter.Operation.html#t:args/0","title":"Skitter.Operation.args/0","type":"type"},{"doc":"Configuration passed to the callback when it is called. The configuration represents the immutable state of an operation. It is explicitly separated from the mutable state/0 to enable strategies to explicitly differentiate between handling mutable and immutable data.","ref":"Skitter.Operation.html#t:config/0","title":"Skitter.Operation.config/0","type":"type"},{"doc":"Output emitted by a callback. Emitted data is returned as a keyword list where the output for each out port is specified. When no data is emitted on a port, the port should be omitted from the list. The data emitted by a callback for a port should be wrapped in an Enumerable.t/0 . Each element in this enumerable will be sent to downstream nodes separately.","ref":"Skitter.Operation.html#t:emit/0","title":"Skitter.Operation.emit/0","type":"type"},{"doc":"Additional callback information. Can be retrieved with info/2 . The following information is stored: :read? : Boolean which indicates if the callback reads the operation state. :write? : Boolean which indicates if the callback updates the operation state. :emit : Boolean which indicates if the callback emits data.","ref":"Skitter.Operation.html#t:info/0","title":"Skitter.Operation.info/0","type":"type"},{"doc":"Input/output interface of Skitter operations. The ports of an operation determine its external interface. A port can be referred to by its index in the in or out ports list of an operation. in_port_to_index/2 and out_port_to_index/2 can be used to convert a port name to a port index. Names are used in the workflow and operation DSLs, while indices are used inside strategies.","ref":"Skitter.Operation.html#t:port_index/0","title":"Skitter.Operation.port_index/0","type":"type"},{"doc":"Input/output interface of Skitter operations. The ports of an operation determine its external interface. A port can be referred to by its name, which is stored as an atom. in_port_to_index/2 and out_port_to_index/2 can be used to convert a port name to a port index. Names are used in the workflow and operation DSLs, while indices are used inside strategies.","ref":"Skitter.Operation.html#t:port_name/0","title":"Skitter.Operation.port_name/0","type":"type"},{"doc":"Values returned by a callback when it is called. The following information is stored: :result : The actual result of the callback, i.e. the final value returned in its body. :state : The (possibly modified) state after calling the callback. :emit : The list of output emitted by the callback.","ref":"Skitter.Operation.html#t:result/0","title":"Skitter.Operation.result/0","type":"type"},{"doc":"State passed to the callback when it is called.","ref":"Skitter.Operation.html#t:state/0","title":"Skitter.Operation.state/0","type":"type"},{"doc":"An operation is defined as a module. This module should implement the Skitter.Operation behaviour.","ref":"Skitter.Operation.html#t:t/0","title":"Skitter.Operation.t/0","type":"type"},{"doc":"Strategy type definition and utilities. A strategy is a reusable piece of logic which determines how an operation is distributed at runtime. It is defined as a collection of hooks : functions which each define an aspect of the distributed behaviour of an operation. A strategy is defined as an elixir module which implements the Skitter.Strategy.Operation behaviour. It is recommended to define a strategy using Skitter.DSL.Strategy.defstrategy/3 . This module defines the strategy and context types.","ref":"Skitter.Strategy.html","title":"Skitter.Strategy","type":"module"},{"doc":"Context information for strategy hooks. A strategy hook often needs information about the context in which it is being called. Relevant information about the context is stored inside the context, which is passed as the first argument to every hook. The following information is stored: operation : The operation for which the hook is called. strategy : The strategy of the operation. args : The arguments passed to the node in the workflow. deployment : The current deployment data. nil if the deployment is not created yet (e.g. in deploy ) _skr : Data stored by the runtime system. This data should not be accessed or modified.","ref":"Skitter.Strategy.html#t:context/0","title":"Skitter.Strategy.context/0","type":"type"},{"doc":"Immutable data of a data processing pipeline. A strategy which is deployed over the cluster has access to an immutable set of data which is termed the deployment . A strategy can specify which data to store in its deployment inside the Skitter.Strategy.Operation.deploy/1 hook. Afterwards, the other strategy hooks have access to the data stored within the deployment. Note that an operation strategy can only access its own deployment data.","ref":"Skitter.Strategy.html#t:deployment/0","title":"Skitter.Strategy.deployment/0","type":"type"},{"doc":"A strategy is defined as a module.","ref":"Skitter.Strategy.html#t:t/0","title":"Skitter.Strategy.t/0","type":"type"},{"doc":"Workflow type definition and utilities. A reactive workflow defines a data processing pipeline. It is defined as a set of nodes connected through various links. A node contains a data processing operation and its distribution strategy. A workflow stores these nodes and links between them, along with additional meta-information about the workflow. In order to enable the reuse of workflows, workflows may define in -and out ports. When this is done, these workflows may be embedded inside another workflow. Note that a workflow is always flattened using flatten/1 before it is deployed. This module defines the workflow type along with some utilities to work with this type. It is not recommended to define a workflow manually. Instead, the use of Skitter.DSL.Workflow.workflow/2 is preferred.","ref":"Skitter.Workflow.html","title":"Skitter.Workflow","type":"module"},{"doc":"Recursively inline any nested workflow of a workflow. This function ensures any workflow embedded in the provided workflow is inlined into the provided workflow. Examples will be converted to: iex&gt; defoperation Simple , in : p , out : p do ...&gt; end iex&gt; defoperation Join , in : [ left , right ] , out : p do ...&gt; end iex&gt; inner = % Workflow { ...&gt; in : [ foo : [ node1 : :p , node2 : :p ] ] , ...&gt; out : [ :bar ] , ...&gt; nodes : %{ ...&gt; node1 : % Node.Operation { operation : Simple , links : [ p : [ node3 : :left ] ] } , ...&gt; node2 : % Node.Operation { operation : Simple , links : [ p : [ node3 : :right ] ] } , ...&gt; node3 : % Node.Operation { operation : Join , links : [ p : [ :bar ] ] } ...&gt; } } iex&gt; parent = % Workflow { ...&gt; nodes : %{ ...&gt; node_pre : % Node.Operation { operation : Simple , links : [ p : [ nested1 : :foo , nested2 : :foo ] ] } , ...&gt; nested1 : % Node.Workflow { workflow : inner , links : [ bar : [ node_post : :left ] ] } , ...&gt; nested2 : % Node.Workflow { workflow : inner , links : [ bar : [ node_post : :right ] ] } , ...&gt; node_post : % Node.Operation { operation : Join } ...&gt; } } iex&gt; flatten ( parent ) % Workflow { nodes : %{ node_pre : % Node.Operation { operation : Skitter.WorkflowTest.Simple , links : [ p : [ &quot;nested1#node1&quot; : :p , &quot;nested1#node2&quot; : :p , &quot;nested2#node1&quot; : :p , &quot;nested2#node2&quot; : :p ] ] } , &quot;nested1#node1&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Simple , links : [ p : [ &quot;nested1#node3&quot; : :left ] ] } , &quot;nested1#node2&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Simple , links : [ p : [ &quot;nested1#node3&quot; : :right ] ] } , &quot;nested1#node3&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Join , links : [ p : [ node_post : :left ] ] } , &quot;nested2#node1&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Simple , links : [ p : [ &quot;nested2#node3&quot; : :left ] ] } , &quot;nested2#node2&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Simple , links : [ p : [ &quot;nested2#node3&quot; : :right ] ] } , &quot;nested2#node3&quot; : % Node.Operation { operation : Skitter.WorkflowTest.Join , links : [ p : [ node_post : :right ] ] } , node_post : % Node.Operation { operation : Skitter.WorkflowTest.Join } } }","ref":"Skitter.Workflow.html#flatten/1","title":"Skitter.Workflow.flatten/1","type":"function"},{"doc":"Verify if the links in a workflow are valid. This function verifies if every link in the workflow has a valid source and destination. That is, the link should depart from an existing workflow or operation port and arrive at one. Note that this function does not traverse nested workflows. Examples iex&gt; defoperation Example , in : p , out : p do ...&gt; end iex&gt; verify ( % Workflow { nodes : %{ ...&gt; foo : % Node.Operation { operation : Example , links : [ p : [ bar : :p ] ] } , ...&gt; bar : % Node.Operation { operation : Example } , ...&gt; } } ) :ok iex&gt; verify ( % Workflow { nodes : %{ ...&gt; foo : % Node.Operation { operation : Example , links : [ p : [ baz : :p ] ] } , ...&gt; bar : % Node.Operation { operation : Example } , ...&gt; } } ) [ { { :foo , :p } , { :baz , :p } } ]","ref":"Skitter.Workflow.html#verify/1","title":"Skitter.Workflow.verify/1","type":"function"},{"doc":"Verify if the links in a workflow are valid using verify/1 . This function uses verify/1 to verify if every link in a workflow has a valid source and destination. If this is not the case, it raises a Skitter.DefinitionError . When the workflow is valid, the worfklow itself is returned. Examples iex&gt; defoperation Example , in : p , out : p do ...&gt; end iex&gt; verify! ( % Workflow { nodes : %{ ...&gt; foo : % Node.Operation { operation : Example , links : [ p : [ bar : :p ] ] } , ...&gt; bar : % Node.Operation { operation : Example } , ...&gt; } } ) % Workflow { nodes : %{ foo : % Node.Operation { operation : Skitter.WorkflowTest.Example , links : [ p : [ bar : :p ] ] } , bar : % Node.Operation { operation : Skitter.WorkflowTest.Example } , } } iex&gt; verify! ( % Workflow { nodes : %{ ...&gt; foo : % Node.Operation { operation : Example , links : [ p : [ baz : :p ] ] } , ...&gt; bar : % Node.Operation { operation : Example } , ...&gt; } } ) ** (Skitter.DefinitionError) Invalid link: {:foo, :p} ~&gt; {:baz, :p}","ref":"Skitter.Workflow.html#verify!/1","title":"Skitter.Workflow.verify!/1","type":"function"},{"doc":"Operation initialization arguments This type stores the arguments passed to the operation in the workflow definition.","ref":"Skitter.Workflow.html#t:args/0","title":"Skitter.Workflow.args/0","type":"type"},{"doc":"Link destination. This type stores the destination of a link. A link can point to a port of a node or to an out port of the workflow. In the first case, the name of the node and its out port are stored, in the second, only the name of the out port is stored.","ref":"Skitter.Workflow.html#t:destination/0","title":"Skitter.Workflow.destination/0","type":"type"},{"doc":"Collection of outgoing links. Links are stored as a keyword list. Each key in this list represents an out port, while the value of this key is a list which references the destinations of this out port.","ref":"Skitter.Workflow.html#t:links/0","title":"Skitter.Workflow.links/0","type":"type"},{"doc":"Instance name A name is used to refer to a node embedded inside a workflow.","ref":"Skitter.Workflow.html#t:name/0","title":"Skitter.Workflow.name/0","type":"type"},{"doc":"Operation embedded inside a workflow. An operation in a workflow is stored along with its strategy, initialization arguments (which are passed to Skitter.Strategy.Operation.deploy/1 ) and the outgoing links of each of its out ports. Workflows can override the strategy of an operation, therefore, the strategy specified here may not be the same as the strategy returned by Skitter.Operation.strategy/1 .","ref":"Skitter.Workflow.html#t:operation_node/0","title":"Skitter.Workflow.operation_node/0","type":"type"},{"doc":"Internal workflow representation. A workflow is stored as a map, where each name refers to a single node, which is either a t:operation/0 or t:workflow/0 . Besides this, the in -and out ports of the workflow are stored. The outgoing links of the in ports of a workflow are stored along with the in ports.","ref":"Skitter.Workflow.html#t:t/0","title":"Skitter.Workflow.t/0","type":"type"},{"doc":"Workflow embedded inside a workflow. A workflow nested inside a workflow is stored along with the outgoing links of its out ports.","ref":"Skitter.Workflow.html#t:workflow_node/0","title":"Skitter.Workflow.workflow_node/0","type":"type"},{"doc":"Operation strategy behaviour. This module defines and documents the various hooks a Skitter.Strategy for an operation should implement, along with the functions it can use to access the runtime system.","ref":"Skitter.Strategy.Operation.html","title":"Skitter.Strategy.Operation","type":"behaviour"},{"doc":"Accept data sent to the operation node and send it to a worker. This hook is called by the runtime system when data needs to be sent to a given operation (i.e. when a predecessor of the operation node emits data). It receives the data to be sent along with the index of the port to which the data should be sent. The result of this hook is ignored. Instead, this hook should use Skitter.Worker.send/2 to transfer the received data to a worker. Context All context data (operation, strategy and deployment data) is available when this hook is called.","ref":"Skitter.Strategy.Operation.html#c:deliver/3","title":"Skitter.Strategy.Operation.deliver/3","type":"callback"},{"doc":"Deploy an operation over the cluster. This hook is called by the runtime system when an operation has to be distributed over the cluster. Any data returned by this hook is made available to other hooks through the deployment field in Skitter.Strategy.context/0 . Context When this hook is called, only the current strategy, operation and arguments are available in the context.","ref":"Skitter.Strategy.Operation.html#c:deploy/1","title":"Skitter.Strategy.Operation.deploy/1","type":"callback"},{"doc":"Emit values. This function causes the current operation node to emit data. In other words, the provided data will be sent to the operation nodes connected to the out ports of the current operation node. This function accepts a keyword list of {out_port, enum} pairs. Each element in enum will be sent to the in ports of the operation nodes connected to out_port . Note that data is emitted from the current worker. This may cause issues when infinite streams of data are emitted.","ref":"Skitter.Strategy.Operation.html#emit/2","title":"Skitter.Strategy.Operation.emit/2","type":"function"},{"doc":"Handle a message received by a worker. This hook is called by the runtime when a worker process receives a message. It is called with the received message, the data of the worker that received the message and its tag. This hook should return the new state of the worker that received the message. Context All context data (operation, strategy and the deployment data) is available when this hook is called.","ref":"Skitter.Strategy.Operation.html#c:process/4","title":"Skitter.Strategy.Operation.process/4","type":"callback"},{"doc":"Facilities to interact with remote Skitter runtimes. This module offers facilities to query Skitter about the available remote Skitter runtimes and their properites. It also defines various functions which can be used to spawn Skitter workers on remote Skitter nodes.","ref":"Skitter.Remote.html","title":"Skitter.Remote","type":"module"},{"doc":"Attempt to connect to remote . This function verifies if remote is a valid Skitter node and tries to connect to it. If the connection is successful, this functions tries to find a bound handler for the local mode. If this works, {:ok, mode} is returned, where mode is the mode of the remote runtime. If the expected_mode argument is passed, connect/2 only connects to the remote runtime if its mode is equal to expected_mode . The following errors may be returned if the connection does not succeed: {:error, :not_distributed} : the local node is not alive according to Node.alive?/0 {:error, :not_connected} : it was not possible to connect to the remote runtime {:error, :not_skitter} : the remote node is not a Skitter remote {:error, :incompatible} : the remote node is running an incompatible version of Skitter {:error, :mode_mismatch} : the mode of the remote runtime is not equal to expected_mode {:error, :unknown_mode} : the remote or local runtime does not have a handler for the mode of the other runtime. The handler of the local mode may return a custom {:error, reason} tuple.","ref":"Skitter.Remote.html#connect/2","title":"Skitter.Remote.connect/2","type":"function"},{"doc":"Check if the local runtime is connected to the specified remote runtime.","ref":"Skitter.Remote.html#connected?/1","title":"Skitter.Remote.connected?/1","type":"function"},{"doc":"Get the name of the master node of the cluster.","ref":"Skitter.Remote.html#master/0","title":"Skitter.Remote.master/0","type":"function"},{"doc":"Execute a function n times on every worker runtime. A list of results will be returned for each worker node. These results will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#n_times_on_all_workers/2","title":"Skitter.Remote.n_times_on_all_workers/2","type":"function"},{"doc":"Execute fun on remote , block until a result is available.","ref":"Skitter.Remote.html#on/2","title":"Skitter.Remote.on/2","type":"function"},{"doc":"Execute mod.func(args) on remote , block until a result is available.","ref":"Skitter.Remote.html#on/4","title":"Skitter.Remote.on/4","type":"function"},{"doc":"Execute a function on every core on every worker runtime. A list of results will be returned for each worker node. These results will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#on_all_worker_cores/1","title":"Skitter.Remote.on_all_worker_cores/1","type":"function"},{"doc":"Execute a function on every worker runtime. The result of each worker will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#on_all_workers/1","title":"Skitter.Remote.on_all_workers/1","type":"function"},{"doc":"Execute a function on every worker runtime. The result of each worker will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#on_all_workers/3","title":"Skitter.Remote.on_all_workers/3","type":"function"},{"doc":"Execute fun on every specified remote runtime, obtain results in a list.","ref":"Skitter.Remote.html#on_many/2","title":"Skitter.Remote.on_many/2","type":"function"},{"doc":"Execute mod.func(args) on every specified remote runtime, obtain results in a list.","ref":"Skitter.Remote.html#on_many/4","title":"Skitter.Remote.on_many/4","type":"function"},{"doc":"Execute a function n times, distributed over the available workers. This is handy when you wish to create n workers distributed over the cluster. The work to be done will be divided over the worker nodes in a round robin fashion. This behaviour may change in the future.","ref":"Skitter.Remote.html#on_n/2","title":"Skitter.Remote.on_n/2","type":"function"},{"doc":"Execute a function on every core on every worker runtime tagged with tag . The result of each worker will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#on_tagged_worker_cores/2","title":"Skitter.Remote.on_tagged_worker_cores/2","type":"function"},{"doc":"Execute a function on every worker runtime tagged with tag . The result of each worker will be returned in a keyword list of {worker, result} pairs.","ref":"Skitter.Remote.html#on_tagged_workers/2","title":"Skitter.Remote.on_tagged_workers/2","type":"function"},{"doc":"Get the name of the current Skitter runtime.","ref":"Skitter.Remote.html#self/0","title":"Skitter.Remote.self/0","type":"function"},{"doc":"Get a list of all the tags of node() .","ref":"Skitter.Remote.html#tags/1","title":"Skitter.Remote.tags/1","type":"function"},{"doc":"Get a list of all the worker runtimes tagged with a given tag/0 .","ref":"Skitter.Remote.html#with_tag/1","title":"Skitter.Remote.with_tag/1","type":"function"},{"doc":"Get a list of the names of all the worker runtimes in the cluster.","ref":"Skitter.Remote.html#workers/0","title":"Skitter.Remote.workers/0","type":"function"},{"doc":"Worker tag. A worker may be started with a tag, which indicates properties of the node. For instance, a :gpu tag could be added to a node which has a gpu. Various functions in this module can be used to only spawn workers on nodes with given tags.","ref":"Skitter.Remote.html#t:tag/0","title":"Skitter.Remote.tag/0","type":"type"},{"doc":"Interface to the skitter runtime system.","ref":"Skitter.Runtime.html","title":"Skitter.Runtime","type":"module"},{"doc":"Deploy a workflow. Starts a Skitter application (i.e. a workflow) by deploying it over the cluster. Returns a reference to the deployed workflow.","ref":"Skitter.Runtime.html#deploy/1","title":"Skitter.Runtime.deploy/1","type":"function"},{"doc":"Get the workflow for a reference or context. The workflow will not have any in or out ports and only contain operation nodes, since deploy/1 flattens workflows before it deploys them.","ref":"Skitter.Runtime.html#get_workflow/1","title":"Skitter.Runtime.get_workflow/1","type":"function"},{"doc":"Get the current runtime mode. This function returns the mode of the current runtime. The available modes and their goal are documented in the configuration documentation . This function may also return :test , which is only used for testing.","ref":"Skitter.Runtime.html#mode/0","title":"Skitter.Runtime.mode/0","type":"function"},{"doc":"Get the workflow node based on a context. The workflow node will always be an operation node.","ref":"Skitter.Runtime.html#node_for_context/1","title":"Skitter.Runtime.node_for_context/1","type":"function"},{"doc":"Get the name of the workflow node based on a context.","ref":"Skitter.Runtime.html#node_name_for_context/1","title":"Skitter.Runtime.node_name_for_context/1","type":"function"},{"doc":"Get the reference based on a context. This can be used to link a telemetry event which contained a context to a deployed workflow.","ref":"Skitter.Runtime.html#ref_for_context/1","title":"Skitter.Runtime.ref_for_context/1","type":"function"},{"doc":"Get a list with references to every spawned workflow. This function communicates with the master node when called from a worker runtime.","ref":"Skitter.Runtime.html#spawned_workflows/0","title":"Skitter.Runtime.spawned_workflows/0","type":"function"},{"doc":"Stop the workflow with reference ref .","ref":"Skitter.Runtime.html#stop/1","title":"Skitter.Runtime.stop/1","type":"function"},{"doc":"Reference to a deployed workflow.","ref":"Skitter.Runtime.html#t:ref/0","title":"Skitter.Runtime.ref/0","type":"type"},{"doc":"Worker which manages state and performs computations for an operation and its strategy. Workers are spawned by strategies to manage state and perform computations for a given operation. Any operation or strategy state not stored in the deployment lives in a worker. Skitter workers are created by strategies with an initial state. Any messages received by the worker are handled by the Skitter.Strategy.Operation.process/4 hook of its strategy. This callback receives the current worker state and may return a new, updated state to be stored by the worker. Since strategies can create many separate workers, each worker is created with a tag which can be used by the strategy to provide different implementations of Skitter.Strategy.Operation.process/4 based on the worker that received the message. This module defines the worker types and various functions to deal with workers.","ref":"Skitter.Worker.html","title":"Skitter.Worker","type":"module"},{"doc":"Create a new worker on the local node. This will raise when executed on a master node.","ref":"Skitter.Worker.html#create_local/3","title":"Skitter.Worker.create_local/3","type":"function"},{"doc":"Create a new worker on a remote node. The worker will be placed on a random node, subject to the passed placement constraints.","ref":"Skitter.Worker.html#create_remote/4","title":"Skitter.Worker.create_remote/4","type":"function"},{"doc":"Send a message to the worker at ref .","ref":"Skitter.Worker.html#send/2","title":"Skitter.Worker.send/2","type":"function"},{"doc":"Stop worker ref .","ref":"Skitter.Worker.html#stop/1","title":"Skitter.Worker.stop/1","type":"function"},{"doc":"Placement constraints. When spawning a remote worker, it is often desirable to tweak on which node the worker will be placed. This type defines a set of placement constraints which can be passed as an argument to create_remote/4 . The following constraints are defined: nil : No constraints. on: node : Spawn the worker at the specified node. with: ref : Spawn the worker on the same node as the worker identified by ref . avoid: ref : Try to place the worker on a different node than the worker identified by ref . avoid: node : Try to avoid placing the worker on node . tagged: tag : Try to place the worker on a node with a specific t:Skitter.Nodes.tag/0 . Note that it is not always possible to match the desired constraints. When this is the case, a warning will be logged.","ref":"Skitter.Worker.html#t:placement/0","title":"Skitter.Worker.placement/0","type":"type"},{"doc":"Reference to a created worker.","ref":"Skitter.Worker.html#t:ref/0","title":"Skitter.Worker.ref/0","type":"type"},{"doc":"Worker state.","ref":"Skitter.Worker.html#t:state/0","title":"Skitter.Worker.state/0","type":"type"},{"doc":"Worker state or a function which returns a worker state. Functions which create workers may be created with an initial state, or with a function which returns an initial state.","ref":"Skitter.Worker.html#t:state_or_state_fn/0","title":"Skitter.Worker.state_or_state_fn/0","type":"type"},{"doc":"Worker tag. Each worker is tagged with an atom which allows the strategy to differentiate between the various workers it creates.","ref":"Skitter.Worker.html#t:tag/0","title":"Skitter.Worker.tag/0","type":"type"},{"doc":"Domain-specific language support for Skitter. This module enables the various DSLs offered by Skitter. use Skitter.DSL imports: Skitter.DSL.Operation.defoperation/3 Skitter.DSL.Strategy.defstrategy/3 Skitter.DSL.Workflow.workflow/2","ref":"Skitter.DSL.html","title":"Skitter.DSL","type":"module"},{"doc":"Callback and Operation definition DSL. This module offers macros to define operation modules and callbacks. Please refer to the documentation of defoperation/3 .","ref":"Skitter.DSL.Operation.html","title":"Skitter.DSL.Operation","type":"module"},{"doc":"Updates the current state. This macro should only be used inside the body of defcb/2 . It updates the current value of the operation state to the provided value. This macro can be used in two ways: it can be used to update the operation state or a field of the operation state. The latter option can only be used if the state of the operation is a struct (i.e. if the intial state has been defined using state_struct/1 ). The former options modifies the operation state as a whole, the second option only modifies the value of the provided field stored in the operation state. Examples defoperation WriteExample do defcb write ( ) , do : state &lt;~ :foo end iex&gt; Operation . call ( WriteExample , :write , nil , nil , [ ] ) . state :foo defoperation FieldWriteExample do state_struct [ :field ] defcb write ( ) , do : field &lt;~ :bar end iex&gt; Operation . call ( FieldWriteExample , :write , % FieldWriteExample { field : :foo } , nil , [ ] ) . state . field :bar defoperation WrongFieldWriteExample do fields [ :field ] defcb write ( ) , do : doesnotexist &lt;~ :bar end iex&gt; Operation . call ( WrongFieldWriteExample , :write , % WrongFieldWriteExample { field : :foo } , nil , [ ] ) ** (KeyError) key :doesnotexist not found in: %Skitter.DSL.OperationTest.WrongFieldWriteExample{field: :foo}","ref":"Skitter.DSL.Operation.html#%3C~/2","title":"Skitter.DSL.Operation.<~/2","type":"macro"},{"doc":"Obtain the operation configuration. This macro reads the current value of the configuration passed to the operation callback when it was called. It should only be used inside the body of defcb/2 . Examples defoperation ConfigExample do defcb read ( ) , do : config ( ) end iex&gt; Operation . call ( ConfigExample , :read , [ ] ) . result nil iex&gt; Operation . call ( ConfigExample , :read , :config , [ ] ) . result :config iex&gt; Operation . call ( ConfigExample , :read , :state , :config , [ ] ) . result :config","ref":"Skitter.DSL.Operation.html#config/0","title":"Skitter.DSL.Operation.config/0","type":"macro"},{"doc":"Define a callback. This macro is used to define a callback function. Using this macro, a callback can be defined similar to a regular procedure. Inside the body of the procedure, ~&gt;/2 , ~&gt;&gt;/2 &lt;~/2 and sigil_f/2 can be used to access the state and to emit output. The macro ensures: The function returns a Skitter.Operation.result/0 with the correct state (as updated by &lt;~/2 ), emit (as updated by ~&gt;/2 and ~&gt;&gt;/2 ) and result (which contains the value of the last expression in body ). Skitter.Operation._sk_callback_info/2 and c:Skitter.Callback._sk_callbacks/0 of the operation module contains the required information about the defined callback. Note that, under the hood, defcb/2 generates a regular elixir function. Therefore, pattern matching may still be used in the argument list of the callback. Attributes such as @doc may also be used as usual. Examples defoperation CbExample do defcb simple ( ) , do : nil defcb arguments ( arg1 , arg2 ) , do : arg1 + arg2 defcb state ( ) , do : counter &lt;~ ( ~f{counter} + 1 ) defcb emit_single ( ) , do : ~D[1991-12-08] ~&gt; out_port defcb emit_multi ( ) , do : [ ~D[1991-12-08] , ~D[2021-07-08] ] ~&gt;&gt; out_port end iex&gt; Operation . callbacks ( CbExample ) MapSet . new ( [ arguments : 2 , emit_multi : 0 , emit_single : 0 , simple : 0 , state : 0 ] ) iex&gt; Operation . callback_info ( CbExample , :simple , 0 ) % Info { read? : false , write? : false , emit? : false } iex&gt; Operation . callback_info ( CbExample , :arguments , 2 ) % Info { read? : false , write? : false , emit? : false } iex&gt; Operation . callback_info ( CbExample , :state , 0 ) % Info { read? : true , write? : true , emit? : false } iex&gt; Operation . callback_info ( CbExample , :emit_single , 0 ) % Info { read? : false , write? : false , emit? : true } iex&gt; Operation . callback_info ( CbExample , :emit_multi , 0 ) % Info { read? : false , write? : false , emit? : true } iex&gt; Operation . call ( CbExample , :simple , %{ } , nil , [ ] ) % Result { result : nil , emit : [ ] , state : %{ } } iex&gt; Operation . call ( CbExample , :arguments , %{ } , nil , [ 10 , 20 ] ) % Result { result : 30 , emit : [ ] , state : %{ } } iex&gt; Operation . call ( CbExample , :state , %{ counter : 10 , other : :foo } , nil , [ ] ) % Result { result : nil , emit : [ ] , state : %{ counter : 11 , other : :foo } } iex&gt; Operation . call ( CbExample , :emit_single , %{ } , nil , [ ] ) % Result { result : nil , emit : [ out_port : [ ~D[1991-12-08] ] ] , state : %{ } } iex&gt; Operation . call ( CbExample , :emit_multi , %{ } , nil , [ ] ) % Result { result : nil , emit : [ out_port : [ ~D[1991-12-08] , ~D[2021-07-08] ] ] , state : %{ } } Mutable state and control flow The &lt;~/2 , ~&gt;/2 and ~&gt;&gt;/2 operators add mutable state to Elixir, which is an immutable language. Internally, hidden variables are used to track the current state and values to emit. To make this work, the callback DSL rewrites several control flow structures offered by elixir. While this approach works, some limitations are present when the &lt;~/2 , ~&gt;/2 and ~&gt;&gt;/2 operators are used inside control flow structures. The use of these operators is supported in the following control flow constructs: Kernel.if/2 Kernel.unless/2 Kernel.SpecialForms.try/1 Kernel.SpecialForms.cond/1 Kernel.SpecialForms.case/2 Kernel.SpecialForms.receive/1 With the exception of Kernel.SpecialForms.try/1 , all of these control flow constructs behave as expected. Said otherwise, state updates performed inside any of these constructs are reflected outside of the control flow construct. try The behaviour of try blocks is not as straightforward due to implementation limitations. We describe the different behaviours that may occur below. defcb simple ( fun ) do try do pre &lt;~ :modified res = fun . ( ) post &lt;~ :modified :emit ~&gt; out res rescue RuntimeError -&gt; x &lt;~ :modified :rescue catch _ -&gt; :emit ~&gt; out :catch end end If no exception is raised or no value is thrown, updates performed inside the do block will always be visible: iex&gt; Operation . call ( TryExample , :simple , %{ pre : nil , post : nil } , nil , [ fn -&gt; :foo end ] ) % Result { state : %{ pre : :modified , post : :modified } , result : :foo , emit : [ out : [ :emit ] ] } However, when an exception is raised or a value is thrown, any updates performed inside the do block are discarded: iex&gt; Operation . call ( TryExample , :simple , %{ pre : nil , post : nil , x : nil } , nil , [ fn -&gt; raise RuntimeError end ] ) % Result { state : %{ pre : :nil , post : :nil , x : :modified } , result : :rescue , emit : [ ] } iex&gt; Operation . call ( TryExample , :simple , %{ pre : nil , post : nil } , nil , [ fn -&gt; throw :foo end ] ) % Result { state : %{ pre : :nil , post : :nil } , result : :catch , emit : [ out : [ :emit ] ] } As shown above, updates inside the catch or rescue clauses are reflected in the final result. else and after defcb with_else ( fun ) do try do pre &lt;~ :modified res = fun . ( ) post &lt;~ :modified :emit ~&gt; out res rescue RuntimeError -&gt; :rescue else res -&gt; x &lt;~ :modified res end end Updates inside the do block are reflected in the else block: iex&gt; Operation . call ( TryExample , :with_else , %{ pre : nil , post : nil , x : nil } , nil , [ fn -&gt; :foo end ] ) % Result { state : %{ pre : :modified , post : :modified , x : :modified } , result : :foo , emit : [ out : [ :emit ] ] } Updates inside the after block are ignored: defcb with_after ( fun ) do try do pre &lt;~ :modified res = fun . ( ) post &lt;~ :modified :emit ~&gt; out res rescue RuntimeError -&gt; :rescue after x &lt;~ :modified :ignored end end iex&gt; Operation . call ( TryExample , :with_after , %{ pre : nil , post : nil , x : nil } , nil , [ fn -&gt; :foo end ] ) % Result { state : %{ pre : :modified , post : :modified , x : nil } , result : :foo , emit : [ out : [ :emit ] ] } In short, updates are preserved during the normal flow of an operation (i.e. when no values are raised or thrown), updates inside after are ignored.","ref":"Skitter.DSL.Operation.html#defcb/2","title":"Skitter.DSL.Operation.defcb/2","type":"macro"},{"doc":"Define an operation module. This macro is used to define an operation module. Using this macro, an operation can be defined similar to a normal module. The macro will enable the use of defcb/2 and provides implementations for Skitter.Operation._sk_operation_info/1 , Skitter.Operation._sk_operation_initial_state/0 , Skitter.Operation._sk_callbacks/0 and Skitter.Operation._sk_callback_info/2 . Operation strategy and ports The operation strategy and its in -and out ports can be defined in the header of the operation declaration as follows: iex&gt; defoperation SignatureExample , in : [ a , b , c ] , out : [ y , z ] , strategy : SomeStrategy do ...&gt; end iex&gt; Operation . strategy ( SignatureExample ) SomeStrategy iex&gt; Operation . in_ports ( SignatureExample ) [ :a , :b , :c ] iex&gt; Operation . out_ports ( SignatureExample ) [ :y , :z ] If an operation has no in , or out ports, they can be omitted from the operation's header. Furthermore, if the operation only has a single in or out port, the list notation can be omitted: iex&gt; defoperation PortExample , in : a do ...&gt; end iex&gt; Operation . in_ports ( PortExample ) [ :a ] iex&gt; Operation . out_ports ( PortExample ) [ ] The strategy may be omitted. In this case, a strategy must be provided when the defined operation is embedded inside a workflow. If this is not done, an error will be raised when the workflow is deployed. Examples defoperation Average , in : value , out : current do state_struct total : 0 , count : 0 defcb react ( value ) do total &lt;~ ~f{total} + value count &lt;~ ~f{count} + 1 ~f{total} / ~f{count} ~&gt; current end end iex&gt; Operation . in_ports ( Average ) [ :value ] iex&gt; Operation . out_ports ( Average ) [ :current ] iex&gt; Operation . strategy ( Average ) nil iex&gt; Operation . call ( Average , :react , [ 10 ] ) % Result { result : nil , emit : [ current : [ 10.0 ] ] , state : % Average { count : 1 , total : 10 } } iex&gt; Operation . call ( Average , :react , % Average { count : 1 , total : 10 } , nil , [ 10 ] ) % Result { result : nil , emit : [ current : [ 10.0 ] ] , state : % Average { count : 2 , total : 20 } } Documentation When writing documentation for an operation, @operationdoc can be used instead of the usual @moduledoc . When this is done, this macro will automatically add additional information about the operation to the generated documentation.","ref":"Skitter.DSL.Operation.html#defoperation/3","title":"Skitter.DSL.Operation.defoperation/3","type":"macro"},{"doc":"","ref":"Skitter.DSL.Operation.html#generate_moduledoc/1","title":"Skitter.DSL.Operation.generate_moduledoc/1","type":"macro"},{"doc":"Defines the initial state of an operation. This macro is used to define the initial state of an operation. This state is passed to every called callback when no state is provided by the operation's strategy. When this macro is not used, the initial state of an operation is nil . Internally, this macro generates a definition of Skitter.Operation._sk_operation_initial_state/0 . Examples defoperation NoStateExample do defcb return_state , do : state ( ) end defoperation StateExample do initial_state 0 defcb return_state , do : state ( ) end iex&gt; Operation . initial_state ( NoStateExample ) nil iex&gt; Operation . initial_state ( StateExample ) 0 iex&gt; Operation . call ( NoStateExample , :return_state , [ ] ) . state nil iex&gt; Operation . call ( StateExample , :return_state , [ ] ) . state 0 iex&gt; Operation . call ( NoStateExample , :return_state , :some_state , nil , [ ] ) . state :some_state iex&gt; Operation . call ( StateExample , :return_state , :some_state , nil , [ ] ) . state :some_state","ref":"Skitter.DSL.Operation.html#initial_state/1","title":"Skitter.DSL.Operation.initial_state/1","type":"macro"},{"doc":"Read the current value of a field stored in state. This macro expects that the current operation state is a struct (i.e. it expects an operation that uses state_struct/1 ), and reads the current value of field from the struct. This macro should only be used inside the body of defcb/2 . Examples defoperation FieldReadExample do state_struct field : nil defcb read ( ) , do : ~f{field} end iex&gt; Operation . call ( FieldReadExample , :read , % FieldReadExample { field : 5 } , nil , [ ] ) . result 5 iex&gt; Operation . call ( FieldReadExample , :read , % FieldReadExample { field : :foo } , nil , [ ] ) . result :foo","ref":"Skitter.DSL.Operation.html#sigil_f/2","title":"Skitter.DSL.Operation.sigil_f/2","type":"macro"},{"doc":"Obtain the current state. This macro reads the current value of the state passed to the operation callback when it was called. It should only be used inside the body of defcb/2 . Examples defoperation ReadExample do initial_state 0 defcb read ( ) , do : state ( ) end iex&gt; Operation . call ( ReadExample , :read , [ ] ) . result 0 iex&gt; Operation . call ( ReadExample , :read , :state , nil , [ ] ) . result :state iex&gt; Operation . call ( ReadExample , :read , :state , nil , [ ] ) . result :state","ref":"Skitter.DSL.Operation.html#state/0","title":"Skitter.DSL.Operation.state/0","type":"macro"},{"doc":"Creates an initial struct-based state for an operation. In Elixir, it is common to use a struct to store structured information. Therefore, when an operation manages a complex state, it often defines a struct and uses this struct as the initial state of the operation. Afterwards, the state of the operation is updated when it reacts to incoming data: defoperation Average , in : value , out : current do defstruct [ total : 0 , count : 0 ] state % __MODULE__ { } defcb react ( val ) do state &lt;~ %{ state ( ) | count : state ( ) . count + 1 } state &lt;~ %{ state ( ) | total : state ( ) . total + val } state ( ) . total / state ( ) . count ~&gt; current end end In order to streamline the use of this pattern, this macro defines a struct and uses this struct as the initial state of the operation. Moreover, the sigil_f/2 and &lt;~/2 macros are designed to be used with structs, enabling them to read the state and update it: defoperation Average , in : value , out : current do state_struct total : 0 , count : 0 defcb react ( val ) do count &lt;~ ~f{count} + 1 total &lt;~ ~f{total} + val ~f{total} / ~f{count} ~&gt; current end end The second example generates the code shown in the first example. Examples iex&gt; Operation . initial_state ( Average ) % Average { total : 0 , count : 0 }","ref":"Skitter.DSL.Operation.html#state_struct/1","title":"Skitter.DSL.Operation.state_struct/1","type":"macro"},{"doc":"Emit value to port This macro is used to specify value should be emitted on port . This means that value will be sent to any operations downstream of the current operation. This macro should only be used inside the body of defcb/2 . If a previous value was specified for port , it is overridden. Examples defoperation SingleEmitExample do defcb emit ( value ) do value ~&gt; some_port :foo ~&gt; some_other_port end end iex&gt; Operation . call ( SingleEmitExample , :emit , [ :bar ] ) . emit [ some_other_port : [ :foo ] , some_port : [ :bar ] ]","ref":"Skitter.DSL.Operation.html#~%3E/2","title":"Skitter.DSL.Operation.~>/2","type":"macro"},{"doc":"Emit several values to port This macro works like ~&gt;/2 , but emits several output values to the port instead of a single value. Each value in the provided Enumerable.t/0 will be sent to downstream operations individually. Examples defoperation MultiEmitExample do defcb emit ( value ) do value ~&gt; some_port [ :foo , :bar ] ~&gt;&gt; some_other_port end end iex&gt; Operation . call ( MultiEmitExample , :emit , [ :bar ] ) . emit [ some_other_port : [ :foo , :bar ] , some_port : [ :bar ] ]","ref":"Skitter.DSL.Operation.html#~%3E%3E/2","title":"Skitter.DSL.Operation.~>>/2","type":"macro"},{"doc":"Strategy and Hook definition DSL. This module offers macros to define a strategy and hooks. To define a strategy, use defstrategy/3 . Inside the strategy, defhook/2 can be used to define hooks. Inside the body of the hook, context/0 , operation/0 , strategy/0 and deployment/0 can be used to read information from the current context. Note that it is possible to define a strategy as an elixir module which implements the appropriate behaviour. Using defstrategy/3 instead offers three main advantages: The Skitter.Strategy.context/0 of a hook is passed as an implicit argument, which can be accessed using the aforementioned macros. The helpers defined in Skitter.DSL.Strategy.Helpers can be used. A trait-like mechanism is introduced, which can be used to create new strategies based on existing ones.","ref":"Skitter.DSL.Strategy.html","title":"Skitter.DSL.Strategy","type":"module"},{"doc":"Obtain the context's arguments.","ref":"Skitter.DSL.Strategy.html#args/0","title":"Skitter.DSL.Strategy.args/0","type":"macro"},{"doc":"Obtain the context struct. A strategy hook is called with a Skitter.Strategy.context/0 as its first argument. This macro is used to obtain this struct. Examples iex&gt; defstrategy FullContext do ...&gt; defhook read , do : context ( ) ...&gt; end iex&gt; FullContext . read ( % Context { operation : SomeOperation } ) % Context { operation : SomeOperation }","ref":"Skitter.DSL.Strategy.html#context/0","title":"Skitter.DSL.Strategy.context/0","type":"macro"},{"doc":"Define a hook. This macro defines a single hook of a strategy. While a hook may be defined as a plain elixir function, using this macro offers three advantages: The hook context is handled by the macro and can be accessed with context/0 , operation/0 , strategy/0 and deployment/0 . The macros defined in Skitter.DSL.Strategy.Helpers can be used, reducing the code needed to spawn workers, or call operation callbacks. Other strategies can inherit this hook, making it easier to create new strategies. This is shown in the documentation of defstrategy/3 . Calling hooks Hooks defined inside other strategies may be called like a normal elixir function inside the body of a hook. When this occurs, defhook/2 automatically passes the context argument to the hook that is called. iex&gt; defstrategy S1 do ...&gt; defhook example , do : &quot;world!&quot; ...&gt; end iex&gt; defstrategy S2 do ...&gt; defhook example , do : &quot;Hello, &quot; &lt;&gt; S1 . example ( ) ...&gt; end iex&gt; S2 . example ( % Context { } ) &quot;Hello, world!&quot; The same cannot be done when a local hook (i.e. a hook defined in the current module) is called. Therefore, a local hook should be called with a context argument. context/0 can be used for this: iex&gt; defstrategy Local do ...&gt; defhook left , do : &quot;Hello, &quot; ...&gt; defhook right , do : &quot;world!&quot; ...&gt; defhook example , do : left ( context ( ) ) &lt;&gt; right ( context ( ) ) ...&gt; end iex&gt; Local . example ( % Context { } ) &quot;Hello, world!&quot; A hook of a child strategy can also be called dynamically in a similar way: iex&gt; defstrategy Abstract do ...&gt; defhook example , do : &quot;Child says: &quot; &lt;&gt; strategy ( ) . say ( context ( ) ) ...&gt; end iex&gt; defstrategy Child , extends : Abstract do ...&gt; defhook say , do : &quot;Hello!&quot; ...&gt; end iex&gt; Child . example ( % Context { strategy : Child } ) &quot;Child says: Hello!&quot;","ref":"Skitter.DSL.Strategy.html#defhook/2","title":"Skitter.DSL.Strategy.defhook/2","type":"macro"},{"doc":"Define a strategy. This macro is used to define a strategy module. Through the use of this macro, a strategy module can be defined from scratch or based on one or more existing strategies. This macro enables the use of defhook/2 , which is used to define a strategy hook . A hook is an elixir function which accepts a Skitter.Strategy.context/0 as its first argument. This context argument is implicitly created by the defhook/2 macro; the various fields of the context can be accessed through the use of context/0 , operation/0 , strategy/0 and deployment/0 . Besides the context argument, hooks offer one additional feature: they can be inherited by other strategies. Extending Strategies A strategy can be created based on an existing strategy. This is done by extending some strategy. When a strategy extends another strategy, it will inherit all the hooks defined by the strategy it extends: iex&gt; defstrategy Parent do ...&gt; defhook example , do : :example_hook ...&gt; end iex&gt; defstrategy Child , extends : Parent do ...&gt; end iex&gt; Child . example ( % Context { } ) :example_hook Inherited hooks can be overridden: iex&gt; defstrategy Parent do ...&gt; defhook example , do : :parent ...&gt; end iex&gt; defstrategy Child , extends : Parent do ...&gt; defhook example , do : :child ...&gt; end iex&gt; Child . example ( % Context { } ) :child Finally, a strategy can extend multiple parent strategies. When this is done, the hooks of earlier parent strategies take precedence over later hooks: iex&gt; defstrategy Parent1 do ...&gt; defhook example , do : :parent1 ...&gt; end iex&gt; defstrategy Parent2 do ...&gt; defhook example , do : :parent2 ...&gt; defhook another , do : :parent2 ...&gt; end iex&gt; defstrategy Child , extends : [ Parent1 , Parent2 ] do ...&gt; end iex&gt; Child . example ( % Context { } ) :parent1 iex&gt; Child . another ( % Context { } ) :parent2 Note that some caveats apply when hooks call other hooks. These are described in the documentation of defhook/2 .","ref":"Skitter.DSL.Strategy.html#defstrategy/3","title":"Skitter.DSL.Strategy.defstrategy/3","type":"macro"},{"doc":"Obtain the context's deployment. Examples iex&gt; defstrategy ReadDeployment do ...&gt; defhook read , do : deployment ( ) ...&gt; end iex&gt; ReadDeployment . read ( % Context { deployment : :some_deployment_data } ) :some_deployment_data","ref":"Skitter.DSL.Strategy.html#deployment/0","title":"Skitter.DSL.Strategy.deployment/0","type":"macro"},{"doc":"Obtain the context's operation. Examples iex&gt; defstrategy ReadOperation do ...&gt; defhook read , do : operation ( ) ...&gt; end iex&gt; ReadOperation . read ( % Context { operation : SomeOperation } ) SomeOperation","ref":"Skitter.DSL.Strategy.html#operation/0","title":"Skitter.DSL.Strategy.operation/0","type":"macro"},{"doc":"Obtain the context's strategy. Examples iex&gt; defstrategy ReadStrategy do ...&gt; defhook read , do : strategy ( ) ...&gt; end iex&gt; ReadStrategy . read ( % Context { strategy : ReadStrategy } ) Skitter.DSL.StrategyTest.ReadStrategy","ref":"Skitter.DSL.Strategy.html#strategy/0","title":"Skitter.DSL.Strategy.strategy/0","type":"macro"},{"doc":"Macros to be used in strategy hooks. This module defines various macro &quot;primitives&quot; to be used in Skitter.DSL.Strategy.defhook/2 . The contents of this module are automatically available inside defhook . The macros defined in this module do not offer new functionality. Instead, they provide syntactic sugar over calling existing functions with arguments based on the context passed to the strategy hook.","ref":"Skitter.DSL.Strategy.Helpers.html","title":"Skitter.DSL.Strategy.Helpers","type":"module"},{"doc":"Call callback of the current operation with args . Uses Skitter.Operation.call/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#call/1","title":"Skitter.DSL.Strategy.Helpers.call/1","type":"macro"},{"doc":"Call callback of the current operation with args . Uses Skitter.Operation.call/3 .","ref":"Skitter.DSL.Strategy.Helpers.html#call/2","title":"Skitter.DSL.Strategy.Helpers.call/2","type":"macro"},{"doc":"Call callback of the current operation with args and config . Uses Skitter.Operation.call/4 .","ref":"Skitter.DSL.Strategy.Helpers.html#call/3","title":"Skitter.DSL.Strategy.Helpers.call/3","type":"macro"},{"doc":"Call callback of the current operation with state , config and args . Uses Skitter.Operation.call/5 .","ref":"Skitter.DSL.Strategy.Helpers.html#call/4","title":"Skitter.DSL.Strategy.Helpers.call/4","type":"macro"},{"doc":"Call callback of the current operation if it exists. Uses Skitter.Operation.call_if_exists/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#call_if_exists/1","title":"Skitter.DSL.Strategy.Helpers.call_if_exists/1","type":"macro"},{"doc":"Call callback of the current operation if it exists. Uses Skitter.Operation.call_if_exists/3 .","ref":"Skitter.DSL.Strategy.Helpers.html#call_if_exists/2","title":"Skitter.DSL.Strategy.Helpers.call_if_exists/2","type":"macro"},{"doc":"Call callback of the current operation if it exists. Uses Skitter.Operation.call_if_exists/4 .","ref":"Skitter.DSL.Strategy.Helpers.html#call_if_exists/3","title":"Skitter.DSL.Strategy.Helpers.call_if_exists/3","type":"macro"},{"doc":"Call callback of the current operation if it exists. Uses Skitter.Operation.call_if_exists/5 .","ref":"Skitter.DSL.Strategy.Helpers.html#call_if_exists/4","title":"Skitter.DSL.Strategy.Helpers.call_if_exists/4","type":"macro"},{"doc":"Emit data for the current context. Uses Skitter.Strategy.Operation.emit/2","ref":"Skitter.DSL.Strategy.Helpers.html#emit/1","title":"Skitter.DSL.Strategy.Helpers.emit/1","type":"macro"},{"doc":"Raise a Skitter.StrategyError The error is automatically annotated with the current context, which is used to retrieve the current operation and strategy.","ref":"Skitter.DSL.Strategy.Helpers.html#error/1","title":"Skitter.DSL.Strategy.Helpers.error/1","type":"macro"},{"doc":"Get the index of the given in port . Calls Skitter.Operation.in_port_to_index/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#in_port_to_index/1","title":"Skitter.DSL.Strategy.Helpers.in_port_to_index/1","type":"macro"},{"doc":"Get the name of the in port with the given index . Calls Skitter.Operation.index_to_in_port/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#index_to_in_port/1","title":"Skitter.DSL.Strategy.Helpers.index_to_in_port/1","type":"macro"},{"doc":"Get the name of the out port with the given index . Calls Skitter.Operation.index_to_out_port/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#index_to_out_port/1","title":"Skitter.DSL.Strategy.Helpers.index_to_out_port/1","type":"macro"},{"doc":"Create an empty state for the operation. This macro creates an initial state for an operation, by using Skitter.Operation.initial_state/1","ref":"Skitter.DSL.Strategy.Helpers.html#initial_state/0","title":"Skitter.DSL.Strategy.Helpers.initial_state/0","type":"macro"},{"doc":"Create a worker using Skitter.Worker.create_local/3 . This macro creates a local worker, automatically passing the current context.","ref":"Skitter.DSL.Strategy.Helpers.html#local_worker/2","title":"Skitter.DSL.Strategy.Helpers.local_worker/2","type":"macro"},{"doc":"Get the index of the given out port . Calls Skitter.Operation.out_port_to_index/2 .","ref":"Skitter.DSL.Strategy.Helpers.html#out_port_to_index/1","title":"Skitter.DSL.Strategy.Helpers.out_port_to_index/1","type":"macro"},{"doc":"Send a message to a worker using the Elixir's Kernel.send/2 . send/2 and send/3 defined in this module call Skitter.Worker.send/2 which will send a message to a worker, eventually causing its Skitter.Strategy.Operation.process/4 hook to be called. In contrast, this function uses the built-in Kernel.send/2 of Elixir, which sends a message to a pid. This is useful when you need to use Kernel.SpecialForms.receive/1 inside a hook.","ref":"Skitter.DSL.Strategy.Helpers.html#plain_send/2","title":"Skitter.DSL.Strategy.Helpers.plain_send/2","type":"macro"},{"doc":"Create a worker using Skitter.Worker.create_remote/4 . This macro creates a remote worker, automatically passing the current context.","ref":"Skitter.DSL.Strategy.Helpers.html#remote_worker/3","title":"Skitter.DSL.Strategy.Helpers.remote_worker/3","type":"macro"},{"doc":"Send a message to a worker with Skitter.Worker.send/2","ref":"Skitter.DSL.Strategy.Helpers.html#send/2","title":"Skitter.DSL.Strategy.Helpers.send/2","type":"macro"},{"doc":"Stop the current worker using Skitter.Worker.stop/1","ref":"Skitter.DSL.Strategy.Helpers.html#stop_worker/0","title":"Skitter.DSL.Strategy.Helpers.stop_worker/0","type":"macro"},{"doc":"Stop the given worker using Skitter.Worker.stop/1","ref":"Skitter.DSL.Strategy.Helpers.html#stop_worker/1","title":"Skitter.DSL.Strategy.Helpers.stop_worker/1","type":"macro"},{"doc":"Programmatically create output for all out ports. The data must be wrapped in a list.","ref":"Skitter.DSL.Strategy.Helpers.html#to_all_ports/1","title":"Skitter.DSL.Strategy.Helpers.to_all_ports/1","type":"macro"},{"doc":"Programmatically create output for the out port with index . The data must be wrapped in a list.","ref":"Skitter.DSL.Strategy.Helpers.html#to_port/2","title":"Skitter.DSL.Strategy.Helpers.to_port/2","type":"macro"},{"doc":"Workflow definition DSL. This module offers a macro to define workflow. To define a workflow, use workflow/2 . Inside the body of the workflow, node/2 and ~&gt;/2 can be used. Unlike Skitter.DSL.Operation.defoperation/3 and Skitter.DSL.Strategy.defstrategy/3 , the workflow/2 macro does not generate a module, instead, it generates a Skitter.Workflow.t/0 .","ref":"Skitter.DSL.Workflow.html","title":"Skitter.DSL.Workflow","type":"module"},{"doc":"Generate a single workflow node. This macro generates a single node of a workflow. It can only be used inside workflow/2 . It accepts a Skitter.Operation.t/0 or a workflow Skitter.Workflow.t/0 and a list of optional options. The provided operation or workflow will be wrapped inside a Skitter.Workflow.operation_node/0 or Skitter.Workflow.workflow_node/0 . No links will be added to the generated node. Two options can be passed when creating a node: as: and args: : as: defines the name of the node inside the workflow. It can be used to refer to the node when creating links with ~&gt;/2 . If no name is specified, the node macro will generate a unique name. args: defines the arguments to pass to the node. Note that this is only relevant for operation nodes. Arguments passed to workflow nodes are ignored. If no arguments are provided, the arguments of the node defaults to nil . with: defines the strategy to pass to the node. Note that this is only relevant for operation nodes. When a strategy is provided here, it will override the one defined by the operation. If no strategy is provided, the strategy specified by the operation will be used. If no strategy is specified by the operation, an error will be raised. Examples iex&gt; inner = workflow do ...&gt; node Example ...&gt; node Example , as : example_1 ...&gt; node Example , args : :args ...&gt; node Example , as : example_2 , args : :args , with : SomeStrategy ...&gt; end % Skitter.Workflow { in : [ ] , out : [ ] , nodes : %{ &quot;skitter/dsl/workflow_test/example#1&quot; : % Skitter.Workflow.Node.Operation { operation : Example , args : nil , strategy : DefaultStrategy , links : [ ] } , example_1 : % Skitter.Workflow.Node.Operation { operation : Example , args : nil , strategy : DefaultStrategy , links : [ ] } , &quot;skitter/dsl/workflow_test/example#2&quot; : % Skitter.Workflow.Node.Operation { operation : Example , args : :args , strategy : DefaultStrategy , links : [ ] } , example_2 : % Skitter.Workflow.Node.Operation { operation : Example , args : :args , strategy : SomeStrategy , links : [ ] } , } } iex&gt; workflow do ...&gt; node inner ...&gt; node inner , as : nested_1 ...&gt; node inner , args : :will_be_ignored , as : nested_2 ...&gt; end % Skitter.Workflow { in : [ ] , out : [ ] , nodes : %{ &quot;#nested#1&quot; : % Skitter.Workflow.Node.Workflow { workflow : inner , links : [ ] } , nested_1 : % Skitter.Workflow.Node.Workflow { workflow : inner , links : [ ] } , nested_2 : % Skitter.Workflow.Node.Workflow { workflow : inner , links : [ ] } } } iex&gt; workflow do ...&gt; node Join ...&gt; end ** (Skitter.DefinitionError) Operation Elixir.Skitter.DSL.WorkflowTest.Join does not define a strategy and no strategy was specified by the workflow iex&gt; workflow do ...&gt; node Join , with : SomeStrategy ...&gt; end % Skitter.Workflow { in : [ ] , out : [ ] , nodes : %{ &quot;skitter/dsl/workflow_test/join#1&quot; : % Skitter.Workflow.Node.Operation { operation : Join , args : nil , strategy : SomeStrategy , links : [ ] } } }","ref":"Skitter.DSL.Workflow.html#node/2","title":"Skitter.DSL.Workflow.node/2","type":"macro"},{"doc":"Define a workflow. This macro generates a Skitter.Workflow.t/0 . Inside the body of this macro, node/2 and ~&gt;/2 can be used to define nodes and links between nodes, respectively. The generated workflow is verified after its definition through the use of Skitter.Workflow.verify/1 . Workflow ports The ports of a workflow can be defined in the header of the workflow macro as follows: iex&gt; wf = workflow in : [ a ] , out : [ x ] do ...&gt; end iex&gt; wf . in [ a : [ ] ] iex&gt; wf . out [ :x ] If a workflow has no in , or out ports, they can be omitted from the workflow header. Furthermore, if the workflow only has a single in or out port, the list notation can be omitted: iex&gt; wf = workflow in : a do ...&gt; end iex&gt; wf . in [ a : [ ] ] iex&gt; wf . out [ ] Nodes, links and syntactic sugar Inside the body of a workflow, the node/2 and ~&gt;/2 macros are used to define nodes and to link them to one another: iex&gt; wf = workflow do ...&gt; node Example , as : node1 ...&gt; node Example , as : node2 ...&gt; ...&gt; node1 . out_port ~&gt; node2 . in_port ...&gt; end iex&gt; wf . nodes [ :node1 ] . operation Example iex&gt; wf . nodes [ :node1 ] . links [ out_port : [ node2 : :in_port ] ] To link nodes to the in or out ports of a workflow, the port name should be used: iex&gt; wf = workflow in : foo , out : bar do ...&gt; node Example , as : node ...&gt; ...&gt; foo ~&gt; node . in_port ...&gt; node . out_port ~&gt; bar ...&gt; end iex&gt; wf . nodes [ :node ] . links [ out_port : [ :bar ] ] iex&gt; wf . in [ foo : [ node : :in_port ] ] Previously defined workflows may be used inside a workflow definition: iex&gt; inner = workflow in : foo , out : bar do ...&gt; node Example , as : node ...&gt; ...&gt; foo ~&gt; node . in_port ...&gt; node . out_port ~&gt; bar ...&gt; end iex&gt; outer = workflow do ...&gt; node inner , as : inner_left ...&gt; node inner , as : inner_right ...&gt; ...&gt; inner_left . bar ~&gt; inner_right . foo ...&gt; end iex&gt; outer . nodes [ :inner_left ] . workflow == inner true iex&gt; outer . nodes [ :inner_left ] . links [ bar : [ inner_right : :foo ] ] Instead of specifying the complete source name (e.g. node.in_port ), the following syntactic sugar can be used when creating a node: iex&gt; wf = workflow in : foo do ...&gt; foo ~&gt; node ( Example , as : node ) ...&gt; end iex&gt; wf . in [ foo : [ node : :in_port ] ] iex&gt; wf = workflow out : bar do ...&gt; node ( Example , as : node ) ~&gt; bar ...&gt; end iex&gt; wf . nodes [ :node ] . links [ out_port : [ :bar ] ] These uses of ~&gt;/2 can be chained: iex&gt; wf = workflow in : foo , out : bar do ...&gt; foo ...&gt; ~&gt; node ( Example , as : node1 ) ...&gt; ~&gt; node ( Example , as : node2 ) ...&gt; ~&gt; bar ...&gt; end iex&gt; wf . in [ foo : [ node1 : :in_port ] ] iex&gt; wf . nodes [ :node1 ] . links [ out_port : [ node2 : :in_port ] ] iex&gt; wf . nodes [ :node2 ] . links [ out_port : [ :bar ] ] It is not needed to explicitly specify a name for a node if you do not need to refer to the node. You should not rely on the format of the generated names in this case: iex&gt; wf = workflow in : foo , out : bar do ...&gt; foo ...&gt; ~&gt; node ( Example ) ...&gt; ~&gt; node ( Example ) ...&gt; ~&gt; bar ...&gt; end iex&gt; wf . in [ foo : [ &quot;skitter/dsl/workflow_test/example#1&quot; : :in_port ] ] iex&gt; wf . nodes [ :&quot;skitter/dsl/workflow_test/example#1&quot; ] . links [ out_port : [ &quot;skitter/dsl/workflow_test/example#2&quot; : :in_port ] ] iex&gt; wf . nodes [ :&quot;skitter/dsl/workflow_test/example#2&quot; ] . links [ out_port : [ :bar ] ] Skitter.BIO defines various operations along with several macros to use these operations in a workflow. These macros are automatically imported and available inside the body of workflow . iex&gt; sugar = workflow out : bar do ...&gt; tcp_source ( &quot;127.0.0.1&quot; , 4555 ) ...&gt; ~&gt; node ( Example ) ...&gt; ~&gt; bar ...&gt; end iex&gt; zero = workflow out : bar do ...&gt; node ( Skitter.BIO.TCPSource , args : [ address : &quot;127.0.0.1&quot; , port : 4555 ] ) ...&gt; ~&gt; node ( Example ) ...&gt; ~&gt; bar ...&gt; end iex&gt; zero == sugar true Examples iex&gt; workflow in : [ foo , bar ] , out : baz do ...&gt; foo ~&gt; node ( Example ) ~&gt; joiner . left ...&gt; bar ~&gt; node ( Example ) ~&gt; joiner . right ...&gt; ...&gt; node ( Join , with : SomeStrategy , as : joiner ) ...&gt; ~&gt; node ( Example , args : :some_args ) ...&gt; ~&gt; baz ...&gt; end % Skitter.Workflow { in : [ foo : [ &quot;skitter/dsl/workflow_test/example#1&quot; : :in_port ] , bar : [ &quot;skitter/dsl/workflow_test/example#2&quot; : :in_port ] , ] , out : [ :baz ] , nodes : %{ &quot;skitter/dsl/workflow_test/example#1&quot; : % Skitter.Workflow.Node.Operation { operation : Example , args : nil , strategy : DefaultStrategy , links : [ out_port : [ joiner : :left ] ] } , &quot;skitter/dsl/workflow_test/example#2&quot; : % Skitter.Workflow.Node.Operation { operation : Example , args : nil , strategy : DefaultStrategy , links : [ out_port : [ joiner : :right ] ] } , joiner : % Skitter.Workflow.Node.Operation { operation : Join , args : nil , strategy : SomeStrategy , links : [ _ : [ &quot;skitter/dsl/workflow_test/example#3&quot; : :in_port ] ] } , &quot;skitter/dsl/workflow_test/example#3&quot; : % Skitter.Workflow.Node.Operation { operation : Example , args : :some_args , strategy : DefaultStrategy , links : [ out_port : [ :baz ] ] } } }","ref":"Skitter.DSL.Workflow.html#workflow/2","title":"Skitter.DSL.Workflow.workflow/2","type":"macro"},{"doc":"Generate a workflow link. This macro connects two ports in the workflow with each other. It can only be used inside workflow/2 . This macro can be used in various different ways and provides various conveniences to shorten the definition of a workflow. In its most basic form, this macro is used as follows: source ~&gt; destination Where source and destination have one of the following two forms: &lt;operation name&gt;.&lt;port name&gt; : specifies a port of an operation &lt;port name&gt; : specifies a workflow port For instance: iex&gt; wf = workflow in : foo , out : bar do ...&gt; node Example , as : node1 ...&gt; node Example , as : node2 ...&gt; ...&gt; foo ~&gt; node1 . in_port # workflow port ~&gt; operation port ...&gt; node1 . out_port ~&gt; node2 . in_port # operation port ~&gt; operation port ...&gt; node2 . out_port ~&gt; bar # operation port ~&gt; workflow port ...&gt; end iex&gt; wf . in [ foo : [ node1 : :in_port ] ] iex&gt; wf . nodes [ :node1 ] . links [ out_port : [ node2 : :in_port ] ] iex&gt; wf . nodes [ :node2 ] . links [ out_port : [ :bar ] ] Some syntactic sugar is present for linking nodes when they are created: When the left hand side of ~&gt; is a node, a link is created between the first out port of this node and the destination. When the right hand side of ~&gt; is a node, a link is created between the source and the first in port of this node. For instance: iex&gt; wf = workflow in : foo , out : bar do ...&gt; foo ~&gt; node ( Example , as : node1 ) ...&gt; node ( Example , as : node2 ) ~&gt; bar ...&gt; end iex&gt; wf . in [ foo : [ node1 : :in_port ] ] iex&gt; wf . nodes [ :node1 ] . links [ ] iex&gt; wf . nodes [ :node2 ] . links [ out_port : [ :bar ] ] Both the left hand side and the right hand side can be nodes: iex&gt; wf = workflow do ...&gt; node ( Example , as : node1 ) ~&gt; node ( Example , as : node2 ) ...&gt; end iex&gt; wf . nodes [ :node1 ] . links [ out_port : [ node2 : :in_port ] ] Finally, ~&gt; always returns the right hand side as its result. This enables ~&gt; to be chained. iex&gt; wf = workflow in : foo , out : bar do ...&gt; foo ~&gt; node ( Example , as : node1 ) ~&gt; node ( Example , as : node2 ) ~&gt; bar ...&gt; end iex&gt; wf . in [ foo : [ node1 : :in_port ] ] iex&gt; wf . nodes [ :node1 ] . links [ out_port : [ node2 : :in_port ] ] iex&gt; wf . nodes [ :node2 ] . links [ out_port : [ :bar ] ]","ref":"Skitter.DSL.Workflow.html#~%3E/2","title":"Skitter.DSL.Workflow.~>/2","type":"macro"},{"doc":"Shorthands for using BIOs. This module defines various macros which can be used to use the various built-in operations in skitter workflows.","ref":"Skitter.BIO.html","title":"Skitter.BIO","type":"module"},{"doc":"Skitter.BIO.Filter node. Inserts a Skitter.BIO.Filter Skitter.DSL.Workflow.node/2 in the workflow. The argument passed to this macro is passed as an argument to Skitter.BIO.Filter , other options ( as: , with: ) should be passed as a second, optional argument.","ref":"Skitter.BIO.html#filter/2","title":"Skitter.BIO.filter/2","type":"macro"},{"doc":"Skitter.BIO.FlatMap node. Like map/2 , but with Skitter.BIO.FlatMap .","ref":"Skitter.BIO.html#flat_map/2","title":"Skitter.BIO.flat_map/2","type":"macro"},{"doc":"Skitter.BIO.KeyedReduce node. Inserts a Skitter.BIO.KeyedReduce Skitter.DSL.Workflow.node/2 in the workflow. The key_fn , red_fn and initial arguments passed to this macro are passed as arguments to Skitter.BIO.KeyedReduce . Other options ( as: , with: ) can be passed as a fourth argument.","ref":"Skitter.BIO.html#keyed_reduce/4","title":"Skitter.BIO.keyed_reduce/4","type":"macro"},{"doc":"Skitter.BIO.Map node. Inserts a Skitter.BIO.Map Skitter.DSL.Workflow.node/2 in the workflow. The argument passed to this macro is passed as an argument to Skitter.BIO.Map , other options ( as: , with: ) should be passed as a second, optional argument.","ref":"Skitter.BIO.html#map/2","title":"Skitter.BIO.map/2","type":"macro"},{"doc":"Message source node. Inserts a Skitter.BIO.MessageSource node in the workflow. Any options are passed to the workflow.","ref":"Skitter.BIO.html#msg_source/1","title":"Skitter.BIO.msg_source/1","type":"macro"},{"doc":"Skitter.BIO.Print node. Insert a Skitter.BIO.Print node in the workflow. The argument passed to this macro is passed as the print label described in the operation documentation. Workflow options ( as , with ) can be passed as the optional second argument.","ref":"Skitter.BIO.html#print/2","title":"Skitter.BIO.print/2","type":"macro"},{"doc":"Skitter.BIO.Send node. Insert a Skitter.BIO.Send sink in the workflow. The argument passed to this macro is passed as the pid described in the operation documentation. Workflow options ( as , with ) can be passed as the optional second argument. When no argument is provided, self() will be used.","ref":"Skitter.BIO.html#send_sink/2","title":"Skitter.BIO.send_sink/2","type":"macro"},{"doc":"Stream source node. Inserts a Skitter.BIO.StreamSource node in the workflow. The provided enum is passed as an argument to Skitter.BIO.StreamSource . opts are passed as options to the workflow.","ref":"Skitter.BIO.html#stream_source/2","title":"Skitter.BIO.stream_source/2","type":"macro"},{"doc":"Tcp source node. Inserts a Skitter.BIO.TCPSource node in the workflow. The address and ports passed to this argument will be passed as arguments to Skitter.BIO.TCPSource . Provided options are passed to the workflow.","ref":"Skitter.BIO.html#tcp_source/3","title":"Skitter.BIO.tcp_source/3","type":"macro"},{"doc":"Filter operation. This operation implements a filter. When embedded inside a workflow, this operation is provided with a function argument. This function will be called to process every element received by the operation. If the function returns true, the received element will be sent to the accept port. Otherwise, the element will be sent to the reject out port. Operation Properties in ports: _ out ports: accept, reject default strategy: Skitter.BIS.ImmutableLocal","ref":"Skitter.BIO.Filter.html","title":"Skitter.BIO.Filter","type":"module"},{"doc":"FlatMap operation. This operation implements a flatmap. When embedded inside a workflow, this operation is provided with a function argument. This function will be called to process every element received by the operation. This function should return a list. Each element in this list will be emitted on the _ out port. Operation Properties in ports: _ out ports: _ default strategy: Skitter.BIS.ImmutableLocal","ref":"Skitter.BIO.FlatMap.html","title":"Skitter.BIO.FlatMap","type":"module"},{"doc":"Keyed Reduce operation. This operation implements a reduce operation. It accepts three arguments wrapped in a tuple when embedded inside a workflow: a key function, a reduce function and an initial state. When this operation receives data, the key function is called with the received data as its first argument. The key function should return a key, which is used to obtain the state associated with the key. Afterwards, the reduce function is called with the received data as its first argument and the state associated with the key returned by the key function as its second argument. The function should then return a new state, which will be associated with the key. The returned state will also be emitted on the _ out port. Operation Properties in ports: _ out ports: _ default strategy: Skitter.BIS.KeyedState","ref":"Skitter.BIO.KeyedReduce.html","title":"Skitter.BIO.KeyedReduce","type":"module"},{"doc":"Map operation. This operation implements a map. When embedded inside a workflow, this operation is provided with a function argument. This function will be called to process every element received by the operation. The result of applying the function to the received data will be emitted on the _ out port. Operation Properties in ports: _ out ports: _ default strategy: Skitter.BIS.ImmutableLocal","ref":"Skitter.BIO.Map.html","title":"Skitter.BIO.Map","type":"module"},{"doc":"Development source which can receive messages from elixir processes. This operation is a source which can receive data from Elixir messages. After the operation is deployed, send/2 can be used to send a message to the source. Only one message source can exist at the same time. This operation is only intended to be used locally. It does not work in a distributed environment. Operation Properties in ports: none out ports: _ default strategy: Skitter.BIS.PassiveSource","ref":"Skitter.BIO.MessageSource.html","title":"Skitter.BIO.MessageSource","type":"module"},{"doc":"Send a message to the message source.","ref":"Skitter.BIO.MessageSource.html#send/1","title":"Skitter.BIO.MessageSource.send/1","type":"function"},{"doc":"Print operation. This operation print any data element it receives and emits the received value on its out port. This makes it possible to insert this operation in the middle of a data processing pipeline for debugging purposes. A single string should be provided as an argument, this string will be used as a prefix for the printed output. Operation Properties in ports: _ out ports: _ default strategy: Skitter.BIS.ImmutableLocal","ref":"Skitter.BIO.Print.html","title":"Skitter.BIO.Print","type":"module"},{"doc":"Send operation. This operation is a sink that sends any data it receives to a given pid. The pid that should receive the messages should be provided as an argument when the operation is embedded inside a workflow. Operation Properties in ports: _ out ports: none default strategy: Skitter.BIS.ImmutableLocal","ref":"Skitter.BIO.Send.html","title":"Skitter.BIO.Send","type":"module"},{"doc":"Source which produces a stream of predefined data. This operation is a source which is created with a set of data (an Elixir Enumerable ). Once deployed, it will emit each element in the enumerable in order. Operation Properties in ports: none out ports: _ default strategy: Skitter.BIS.StreamSource","ref":"Skitter.BIO.StreamSource.html","title":"Skitter.BIO.StreamSource","type":"module"},{"doc":"TCP source operation. This operation is a source which listens to data on a tcp socket. This operation should be embedded in the workflow with a keyword list as its argument. This list should contain address and port keys, which specify the address and port to connect to, respectively. A data element is emitted for each line sent to the tcp socket. Operation Properties in ports: none out ports: _ default strategy: Skitter.BIS.PassiveSource","ref":"Skitter.BIO.TCPSource.html","title":"Skitter.BIO.TCPSource","type":"module"},{"doc":"Strategy for stateless operations. This strategy can be used for stateless operations. It expects an operation to provide a react callback. When the operation receives data, a worker on the current worker node is selected. The selected worker will call the react callback with the received data. Operation Properties in ports: A single in port is required. out ports: This strategy places no limitations on the out ports of the operation. callbacks: react (required): Called for each incoming data element. conf (optional): Called at deployment time. The result will be passed as config to each invocation of react .","ref":"Skitter.BIS.ImmutableLocal.html","title":"Skitter.BIS.ImmutableLocal","type":"module"},{"doc":"Strategy for stateful operations that can partition their state by key. This strategy can be used for stateful operations with a keyed state. It expects an operation to provided a key and a react callback. When the operation receives data, the key callback will be called to determine the key of the incoming data, afterwards, the value will be sent to a worker maintaining the state for key. This worker might live on another cluster node. Finally, this worker will call the react callback to update the state of the key. Operation Properties in ports: A single in port is required. out ports: This strategy places no limitations on the out ports of the operation. callbacks: key (required): Called for each incoming data element. Can not access operation state. react (required): Called for each incoming data element. init (optional): Called to create an initial state for a key. conf (optional): Called to create a configuration for the operation.","ref":"Skitter.BIS.KeyedState.html","title":"Skitter.BIS.KeyedState","type":"module"},{"doc":"Strategy for reactive source operations. This strategy can be used to create a source operation. It is designed for operations that send data into the workflow as a response to incoming data. When the operation is deployed, the strategy will spawn a single worker and call the operation's subscribe callback with the arguments provided in the workflow. This callback should ensure that messages are sent to the worker in response to external events. Any time a message is sent to the worker, the strategy will call the process callback of the operation, the operation should emit a (list of) data elements based on the received message. The strategy ensures that process is called on a random worker node, to evenly distribute the incoming data over the cluster. Operation Properties in ports: none out ports: This strategy places no limitations on the out ports of the operation. callbacks: subscribe (required): Called at deployment time with the workflow arguments. This callback should ensure the worker receives messages in response to event. process (required): Called for each received message. This callback should emit the list of received data to its out port to push them into the workflow.","ref":"Skitter.BIS.PassiveSource.html","title":"Skitter.BIS.PassiveSource","type":"module"},{"doc":"Strategy for stream-based source operations. This strategy can be used to create a source operation. It is designed for operations which generate a stream of data that is to be sent into the workflow. When the operation is deployed, this strategy will spawn a single worker and call the operations stream callback. This callback should return a stream. Once deployed, the elements of this stream will be emitted by one by one. The strategy ensures these values are shuffled over the available worker nodes. Operation Properties in ports: none out ports: a single out port. callbacks: stream : Called at deployment time. This callback should return a stream, which will be emitted once the operation has been deployed.","ref":"Skitter.BIS.StreamSource.html","title":"Skitter.BIS.StreamSource","type":"module"},{"doc":"Export skitter workflows as graphviz dot graphs. The main function in this module is the to_dot/1 function, which accepts a skitter workflow and returns its dot representation as a string. End users may prefer the print_dot/1 function, which immediately prints the returned string. If dot is installed on the system, the export/3 function can be used to export the generated graph in a variety of formats.","ref":"Skitter.Dot.html","title":"Skitter.Dot","type":"module"},{"doc":"Renders the generated dot graph, requires dot to be installed on the system. This function exports a given workflow to the dot language (using to_dot/1 ), after which it calls dot on the generated dot representation. When dot returns successfully, {:ok, string} is returned, where string is the output generated by dot . A format should be specified. This format is passed to dot through the use of its -T option. For a list of the options supported on your system, see man dot . An optional list of options may be passed to further configure the use of dot . The following options are supported: dot_exe : the path to the dot executable, by default, this function assumes dot is present in your $PATH . extra : a list of extra arguments to pass to the dot executable. Examples Save workflow as a svg file: render ( workflow , &quot;svg&quot; )","ref":"Skitter.Dot.html#render/3","title":"Skitter.Dot.render/3","type":"function"},{"doc":"Renders the generated dot graph and save it to path . Renders the provided workflow (with render/3 ) and store the output to path . format and opts are passed to render/3 .","ref":"Skitter.Dot.html#render_to_file/4","title":"Skitter.Dot.render_to_file/4","type":"function"},{"doc":"Return the dot representation of a workflow as a string.","ref":"Skitter.Dot.html#to_dot/1","title":"Skitter.Dot.to_dot/1","type":"function"},{"doc":"Functions which return the various exit codes a Skitter application may return.","ref":"Skitter.ExitCodes.html","title":"Skitter.ExitCodes","type":"module"},{"doc":"Returned when the runtime shut down because connection to a remote runtime was lost","ref":"Skitter.ExitCodes.html#remote_shutdown/0","title":"Skitter.ExitCodes.remote_shutdown/0","type":"function"},{"doc":"Utilities for building Skitter releases. Releases ( mix release ) are used to deploy Skitter applications over a cluster. Skitter includes several configuration files and scripts to customize the generated release and to faciliate its distribution. In order for your application to use these scripts, your release configuration should use the step/1 function defined in this module: def project do ... , releases : [ &lt; your_release_name &gt; : [ steps : [ &amp; Skitter.Release . step / 1 , :assemble ] ] ] , ... end This will cause Skitter to customize the configuration of your release to include the required configuration files and scripts. Please refer to the deployment page for more information about Skitter releases and how to use them.","ref":"Skitter.Release.html","title":"Skitter.Release","type":"module"},{"doc":"Customize the release assembly. This function customizes the configuration of a release to include several Skitter configuration files and scripts. Concretely, it makes the following modifications: Modify the release to only include unix executables. Add Skitter-specific env.sh.eex and vm.args files. Add the skitter deploy script used to manage Skitter runtime systems. Adds a skitter.exs script which is used to configure the Skitter runtime based on environment variables before it starts. This function should be added to the steps configuration of your release before the :assemble step. It is best to include it after any other steps, as this enables the function to verify that the Skitter generated configuration does not overwrite user-provided configuration values. The following assumptions about your release configuration are made: The :include_executables_for option is not set. Instead, it is set to [:unix] . The :rel_templates_path option is not set. Instead, it is set to point to a directory containing Skitter specific env.sh.eex and vm.args.eex files.","ref":"Skitter.Release.html#step/1","title":"Skitter.Release.step/1","type":"function"},{"doc":"Raised when an error is encountered in a Operation, Workflow or Strategy. This error can be raised by a Skitter DSL or by a skitter data type. It is raised when invalid syntax is encountered or when a semantic error is present in a Skitter.Operation , Skitter.Workflow or Skitter.Strategy .","ref":"Skitter.DefinitionError.html","title":"Skitter.DefinitionError","type":"exception"},{"doc":"Error raised by a strategy. This error can be raised by a Skitter.Strategy . It is used to indicate the strategy encountered some unexpected situation.","ref":"Skitter.StrategyError.html","title":"Skitter.StrategyError","type":"exception"},{"doc":"[ Homepage ] [ Documentation ] A domain specific language for building scalable, distributed stream processing applications with custom distribution strategies. Built in the context of my PhD at the Software Languages Lab . Skitter Skitter is a reactive workflow system: it makes it possible to define data processing pipelines which respond to incoming data automatically by combining operations into a workflow . A key difference between Skitter and other related technologies is the notion of a distribution strategy : operations in a Skitter workflow specify a strategy which defines how the operation is distributed over a cluster at runtime. This enables developers to select the appropriate distribution strategy for an operation for a given situation. Strategies can be implemented from scratch or built based on existing strategies. More information about Skitter can be found at: https://soft.vub.ac.be/~mathsaey/skitter .","ref":"readme.html","title":"Skitter","type":"extras"},{"doc":"We published about Skitter at the following venues: Skitter: A DSL for Distributed Reactive Workflows (REBLS, November 2018) Note that the version of Skitter discussed in this paper differs significantly from the current version. Information on using this earlier version of Skitter can be found here . Getting started Skitter is developed as a DSL in Elixir . Therefore, Elixir is required to write and run Skitter applications. To install Elixir, please refer to the official documentation . The current version of skitter requires the following Erlang/OTP and Elixir versions. Elixir OTP 1.14 25 We provide a brief introduction to creating and running Skitter projects below. For more detailed information, we recommend browsing the docs . There, you can find detailed documentation on the language abstractions offered by Skitter along with guides detailing how to deploy Skitter applications over a cluster and how to configure them.","ref":"readme.html#publications-and-previous-versions","title":"Skitter - Publications and previous versions","type":"extras"},{"doc":"We have created a mix task to help users create a new Skitter project. This task creates a new mix project, configures it to use Skitter and provides initial example code to help you get started. In order to use this task, you need to add it to your local mix installation (mix is installed as a part of Elixir). You can do this as follows: $ mix archive.install hex skitter_new Once installed, mix skitter.new &lt;project_name&gt; can be used to create a new Skitter project. &lt;project_name&gt; should consist of lower case characters, spaces should be replaced by underscores. The generated project will contain a README.md file with information about the generated code and instructions on how to run the Skitter application. Furthermore, some example code will be present in lib/&lt;project_name&gt;.ex to help you get started.","ref":"readme.html#creating-a-new-skitter-project","title":"Skitter - Creating a new Skitter project","type":"extras"},{"doc":"A mix project can be started by using iex -S mix . This will start iex , the interactive Elixir shell and load the current project. mix will ensure that the Skitter runtime is started. When a Skitter runtime is started using iex -S mix , it starts in the so called local mode. In this mode, the runtime acts as both a master and a worker at the same time, which is useful for development. If you wish to test your application in a slightly more realistic setting, mix skitter.master and mix skitter.worker can be used to simulate multiple separate runtime on your local machine. Please refer to the deployment documentation and the documentation of these tasks for more information. Releases are used to deploy a Skitter application over a cluster. To deploy a skitter application over a cluster, build a release using mix release , afterwards, the Skitter deploy script can be used to deploy your application over the cluster. Please run ./_release/bin/skitter help deploy or refer to the deployment documentation for more information.","ref":"readme.html#running-a-project","title":"Skitter - Running a project","type":"extras"},{"doc":"Mix . install ( [ { :skitter , &quot;~&gt; 0.6&quot; } , { :kino , &quot;~&gt; 0.7&quot; } ] ) defmodule LivebookHelpers do def render ( wf = % Skitter.Workflow { } ) do wf |&gt; Skitter.Dot . render ( &quot;svg&quot; ) |&gt; then ( fn { :ok , image } -&gt; image end ) |&gt; Kino.Image . new ( :svg ) end end Resolving Hex dependencies ... Dependency resolution completed : New : kino 0.7 . 0 logger_file_backend 0.0 . 13 murmur 1.0 . 3 skitter 0.6 . 0 table 0.1 . 2 telemetry 1.1 . 0 * Getting skitter ( Hex package ) * Getting kino ( Hex package ) * Getting table ( Hex package ) * Getting logger_file_backend ( Hex package ) * Getting murmur ( Hex package ) * Getting telemetry ( Hex package ) == &gt; logger_file_backend Compiling 1 file ( . ex ) Generated logger_file_backend app == &gt; table Compiling 5 files ( . ex ) Generated table app == &gt; kino Compiling 36 files ( . ex ) Generated kino app === &gt; Analyzing applications ... === &gt; Compiling telemetry == &gt; murmur Compiling 1 file ( . ex ) warning : use Bitwise is deprecated . import Bitwise instead lib / murmur . ex : 19 : Murmur Generated murmur app == &gt; skitter Compiling 67 files ( . ex ) warning : variable &quot;ctx&quot; is unused ( if the variable is not meant to be used , prefix it with an underscore ) lib / runtime / emit . ex : 18 : Skitter.Runtime.Emit . emit / 2 Generated skitter app 17 : 43 : 56.632 [ info ] Skitter v0 . 6.0 started in local mode 17 : 43 : 56.635 [ info ] Reachable at ` snvkciqs - livebook_app @silverlode ` { :module , LivebookHelpers , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 7 , ... &gt;&gt; , { :render , 1 } }","ref":"language_concepts.html","title":"Language Concepts","type":"extras"},{"doc":"This guide provides a primer on the various language constructs offered by Skitter and how they work together. It is recommended to open this document in Livebook, so you can see the workflow diagrams and play around with the code while going through this guide. Skitter is a Distributed Stream Processing Engine with support for custom distribution strategies. Skitter enables developers to write stream processing applications, which can be distributed over a cluster by its runtime system. A novel concept introduced by Skitter is the notion of a distribution strategy . These strategies determine how the application is distributed over the cluster. This enables developers to select the most appropriate distribution strategy for the various operations in their application. Skitter applications are defined through the use of three constructs: workflows , operations and strategies . A distinct DSL is provided for each of these constructs. Construct DSL Goal Workflow Skitter.DSL.Workflow.workflow/2 Define a stream processing application consisting of several data processing steps. Operation Skitter.DSL.Operation.defoperation/2 Define the data processing logic of a single data processing step. Strategy Skitter.DSL.Strategy.defstrategy/2 Define the distribution logic of a single data processing step. We will discuss each of these concepts, and their DSLs, in detail in the following sections. The following shorthand can be use to import all of the DSLs offered by Skitter. use Skitter.DSL :ok","ref":"language_concepts.html#introduction","title":"Language Concepts - Introduction","type":"extras"},{"doc":"Throughout this document, we will use a wordcount application as a running example. This application will receive phrases and count the occurrence of the various words in these phrases. The output of this application is a map with the current count of all the received words. flowchart LR; source([input stream]) app([wordcount application]) sink([counts map]) source-- hello skitter--&gt;app app -- hello: 1, skitter: 1--&gt; sink The wordcount application will be defined as a Skitter workflow which consists of several different data processing operations . flowchart LR; source([input stream]) sink([counts map]) subgraph wordcount_application direction LR stream_source--&gt;split--&gt;count--&gt;show end source-- hello skitter--&gt;stream_source show -- hello: 1, skitter: 1--&gt; sink At runtime, distribution strategies will take the operations present in the application and distribute them over a cluster. flowchart LR; source([input stream]) sink([counts map]) subgraph wordcount_application direction LR subgraph cluster_node_1 cn_1_source(stream_source) cn_1_split(split) cn_1_count(count) cn_1_source --&gt; cn_1_split --&gt; cn_1_count end subgraph cluster_node_2 cn_2_split(split) cn_2_count(count) cn_2_sink(show) cn_2_split --&gt; cn_2_count --&gt; cn_2_sink end cn_1_source --&gt; cn_2_split cn_1_split --&gt; cn_2_count cn_2_split --&gt; cn_1_count cn_1_count --&gt; cn_2_sink end source-- hello skitter--&gt;cn_1_source cn_2_sink -- hello: 1, skitter: 1--&gt; sink We generate an infinite stream of word combinations to serve as input to our application. words = ~w(Mathijs Wolf Joeri Skitter Workflow Operation Strategy) phrase_stream = Stream . repeatedly ( fn -&gt; # Let&#39;s not drain our battery. Process . sleep ( 100 ) &quot; \#{ Enum . random ( words ) } \#{ Enum . random ( words ) } \#{ Enum . random ( words ) } &quot; end ) # Function &lt; 51.124013645 / 2 in Stream . repeatedly / 1 &gt; This stream contains phrases which contain 3 random words. phrase_stream |&gt; Stream . take ( 3 ) |&gt; Enum . to_list ( ) [ &quot;Operation Operation Wolf&quot; , &quot;Wolf Operation Strategy&quot; , &quot;Joeri Wolf Workflow&quot; ]","ref":"language_concepts.html#running-example-general-overview","title":"Language Concepts - Running Example &amp; General Overview","type":"extras"},{"doc":"Skitter applications are written as workflows created through the use of the Skitter.DSL.Workflow.workflow/2 DSL. A workflow is a combination of several data processing steps called nodes which are linked together. graph LR; stream_source --&gt; split --&gt; count --&gt; show Each node of a workflow consists of two parts: an operation and a strategy . The operation defines the data processing logic of the application, while the strategy defines how the operation is distributed over the cluster at runtime. flowchart TD; node((Node)) oper((Operation)) strat((Strategy)) node-- data processing logic --&gt;oper; node-- distribution logic --&gt;strat; A workflow can be defined using the workflow/2 macro, defined in Skitter.DSL.Workflow . This macro is imported when use Skitter.DSL is used, as above. Before we can create a workflow, we need to define some operations to make the workflow/2 compiler happy. For now, we will create empty operations, which do not containing any actual logic. defoperation Count , in : [ word ] , out : [ word_with_count ] do end defoperation Show , in : [ value ] do end { :module , Show , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 10 , ... &gt;&gt; , nil } This code defines two operations: Count and Show . The in: and out: syntax is used to specify the inputs accepted by the operations and the outputs they produce. A workflow is defined by declaring both nodes and links between them. The node operator is used to create a node with an operation and a strategy, the ~&gt; operator is used to link nodes together. workflow do node ( Skitter.BIO.StreamSource , with : Skitter.BIS.StreamSource , args : phrase_stream , as : source ) node ( Skitter.BIO.FlatMap , with : Skitter.BIS.ImmutableLocal , args : &amp; String . split / 1 , as : split ) node ( Count , with : Skitter.BIS.KeyedState , as : count ) node ( Show , with : Sedentary , as : show ) source . _ ~&gt; split . _ split . _ ~&gt; count . word count . word_with_count ~&gt; show . value end |&gt; LivebookHelpers . render ( ) This code defines a workflow consisting of 4 nodes: source , split , count and show . These nodes are linked together to form a pipeline of data processing steps. Each node defines an operation (the first argument passed to node ) and a strategy (the argument prefixed with with: ). The as: syntax is used to name a node; the args: syntax is used to pass arguments to a node. For instance, we use it to pass our infinite stream to the source node. This workflow uses both the operations we defined above and some built-in operators and strategies provided by Skitter. The operators prefixed with Skitter.BIO are operators defined by Skitter, the strategies prefixed with Skitter.BIS are built-in strategies. As a convention, generic operations (such as Skitter.BIO.FlatMap ) use _ as a name for their in and out ports. The LivebookHelpers.render() call is used to visualise the generated workflow. It is defined in the setup section of this livebook. The workflow definition shown above is quite verbose. workflow/2 offers syntactic sugar to facilitate the creation of workflows. The following workflow definitions are all equivalent to the one shown above. First, node declarations and links can be chained: workflow do node ( Skitter.BIO.StreamSource , with : Skitter.BIS.StreamSource , args : phrase_stream , as : source ) ~&gt; node ( Skitter.BIO.FlatMap , with : Skitter.BIS.ImmutableLocal , args : &amp; String . split / 1 , as : split ) ~&gt; node ( Count , with : Skitter.BIS.KeyedState , as : count ) ~&gt; node ( Show , with : Sedentary , as : show ) end |&gt; LivebookHelpers . render ( ) Second, names can be omitted. In this case, the workflow DSL will generate a node name: workflow do node ( Skitter.BIO.StreamSource , with : Skitter.BIS.StreamSource , args : phrase_stream ) ~&gt; node ( Skitter.BIO.FlatMap , with : Skitter.BIS.ImmutableLocal , args : &amp; String . split / 1 ) ~&gt; node ( Count , with : Skitter.BIS.KeyedState ) ~&gt; node ( Show , with : Sedentary ) end |&gt; LivebookHelpers . render ( ) Many operations define a default distribution strategy. When this is the case, the distribution strategy can be omitted from the workflow definition. When this is done, workflow/2 will use the distribution strategy specified by the operation: workflow do node ( Skitter.BIO.StreamSource , args : phrase_stream ) ~&gt; node ( Skitter.BIO.FlatMap , args : &amp; String . split / 1 ) ~&gt; node ( Count , with : Skitter.BIS.KeyedState ) ~&gt; node ( Show , with : Sedentary ) end |&gt; LivebookHelpers . render ( ) Finally, syntactic sugar is present for using the built-in operations provided by Skitter: workflow do stream_source ( phrase_stream ) ~&gt; flat_map ( &amp; String . split / 1 ) ~&gt; node ( Count , with : Skitter.BIS.KeyedState ) ~&gt; node ( Show , with : Sedentary ) end |&gt; LivebookHelpers . render ( ) The strategy of the operation can still be modified when the shorthand notation is used: workflow do stream_source ( phrase_stream , with : Skitter.BIS.StreamSource ) ~&gt; flat_map ( &amp; String . split / 1 , with : Skitter.BIS.ImmutableLocal ) ~&gt; node ( Count , with : Skitter.BIS.KeyedState ) ~&gt; node ( Show , with : Sedentary ) end |&gt; LivebookHelpers . render ( ) To recap, a workflow is defined as the combination of several data processing steps called nodes . Each node consists of an operation and a strategy . The operation defines the data processing logic, while the strategy defines how the operation is distributed. Skitter.DSL.Workflow.workflow/2 enables the creation of Skitter workflows by declaring nodes (with node ), which can be linked together through the use of the ~&gt; operator. The complete documentation of workflow/2 , ~&gt;/2 and node/2 can be found in Skitter.DSL.Workflow .","ref":"language_concepts.html#workflows","title":"Language Concepts - Workflows","type":"extras"},{"doc":"Operations define the data processing logic of a stream processing application. Each operation represents a single data processing step in the data processing pipeline. An operation is defined as a collection of several callbacks along with some meta-information. The meta-information specifies the inputs accepted by the operation, the output it produces, its initial state and its (optional) default distribution strategy. The callbacks contain the code used to process incoming data elements. A callback is an elixir function which accepts two implicit inputs: a state and a configuration ; both of these arguments are provided by a distribution strategy when the callback is called. Furthermore, a callback always returns a Skitter.Operation.result/0 struct. This struct contains the return value of the callback, along with the updated state and emitted data, which we discuss later. Operations are defined through the use of the Skitter.DSL.Operation.defoperation/2 macro. Inside the body of defoperation , various callbacks can be defined through the use of defcb . Callbacks are defined similar to regular elixir functions, with a few differences: Callbacks accept an implicit state and config argument, which represent the state and configuration of the callback. Inside the body of a callback, state() can be used to access the state, config() can be used to access the configuration data, &lt;~ can be used to update the state and ~&gt; can be used to emit data. Callbacks return a Result struct which contains the return value of the callback's body, the updated state and any data that was emitted through the use of ~&gt; . use Skitter.DSL defoperation Count , in : [ word ] , out : [ word_with_count ] , strategy : Skitter.BIS.KeyedState do initial_state 0 defcb key ( word ) , do : word defcb react ( word ) do state &lt;~ state ( ) + 1 { word , state ( ) } ~&gt; word_with_count end end { :module , Count , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 14 , ... &gt;&gt; , { :react , 3 } } The code above (re)defines the Count operation used by the workflow in our running example. The first line specifies that the Count operation accepts a single input, called word and produces a single output, called word_with_count . It also specifies that the Skitter.BIS.KeyedState strategy is used to distribute this operation when no strategy is passed inside the workflow. The KeyedState strategy partitions the state of an operation over the cluster and requires that an operation implements (at least) two callbacks: key and react . The first is called to determine the key for a given data element, while the second is called to update the state associated with that data element. Since we wish to maintain a count for each word , we use the incoming word as the key. In turn, the strategy will use this key to ensure that each incoming word has its own state. To update this state, the KeyedState strategy will call the react callback with the appropriate state. Inside the body of react , we increment the count of the current word (its state) by one, after which we emit the current count on the word_with_count out port. To summarise, the following happens when a word has to be processed by the Count operation. We leave out the logic that occurs on the strategy side. sequenceDiagram participant S as KeyedState (strategy) participant O as Count (operation) activate S S-&gt;&gt;O: key(&quot;hello&quot;) deactivate S activate O O-&gt;&gt;S: result: &quot;hello&quot; deactivate O activate S S-&gt;&gt;O: react(5, &quot;hello&quot;) deactivate S activate O O-&gt;&gt;S: state: 6, emit: word_with_count: {&quot;hello&quot;, 6} deactivate O activate S deactivate S Callbacks can be called programatically, let's see what happens when we call the count callback with the word &quot;hello&quot;. Skitter.Operation . call ( Count , :key , [ &quot;hello&quot; ] ) % Skitter.Operation.Callback.Result { state : 0 , emit : [ ] , result : &quot;hello&quot; } A callback always returns a result containing both it's current state, the emitted data and it's result (the last value returned in the body of defcb ). It is up to the strategy to decide which of the returned values to use. Note that the call returned a state of 0 . When a callback is called without an explicit state, it's initial state is used instead. This initial state is operation specific. It is defined at line 4 of the definition of Count . When we call an operation, we can explicity specify a value for its state and configuration. Skitter.Operation . call ( Count , :key , 5 , nil , [ &quot;hello&quot; ] ) % Skitter.Operation.Callback.Result { state : 5 , emit : [ ] , result : &quot;hello&quot; } Since key does not modify its state, it is returned unchanged. The defcb implementation ensures a callback always returns a Skitter.Operation.result/0 struct. Modified state and emitted data are added to the result struct. Skitter.Operation . call ( Count , :react , 5 , nil , [ &quot;hello&quot; ] ) % Skitter.Operation.Callback.Result { state : 6 , emit : [ word_with_count : [ { &quot;hello&quot; , 6 } ] ] , result : nil } As we can see, the callback incremented its state by one and emitted some data on the word_with_count out port. To summarize, an operation defines the data processing logic present in the application. It is defined by writing a set of callbacks. The set of callbacks that an operation should specify are determined by its strategy. Besides its callbacks, an operation defines a set of in port and out ports, which define the inputs the operation receives and the values it emits, respectively. Callbacks are called with a state, provided by the strategy. An operation may (optionally) define an initial state, which can be used by the strategy. Finally, an operation can define a default distribution strategy, which is used when no strategy is specified in the workflow. All details can be found in the documentation of Skitter.DSL.Operation.defoperation/2 . We define a single additional operation, which we will use to visualise the output of our workflow inside the livebook. defoperation Show , strategy : Sedentary , in : value do initial_state %{ } defcb conf ( frame ) , do : frame defcb react ( { word , count } ) do state ( ) &lt;~ Map . put ( state ( ) , word , count ) Kino.Frame . render ( config ( ) , state ( ) ) end end { :module , Show , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 14 , ... &gt;&gt; , { :react , 3 } } This operation receives the current word count for a given word, and updates its internal state, which contains the current count of all words. It uses the config() operator to access the configuration data passed by the distribution strategy. This configuration data is created by the conf callback. This callback accepts a so-called &quot;frame&quot;, which we can use to display the current wordcount.","ref":"language_concepts.html#operations","title":"Language Concepts - Operations","type":"extras"},{"doc":"Strategies define how an operation is distributed over a cluster. A strategy is defined in terms of several hooks , each of which is called by the Skitter runtime system in response to certain events. Hook Signature When deploy () -&gt; any() Called for every node in the workflow when a workflow is deployed. deliver data, port -&gt; () Called when a predecessor in the workflow emits data to be sent. process message, state, tag -&gt; state Called when a worker receives a message. As an example, we implement a strategy for the Count operation shown above. defstrategy KeyedState do defhook deploy do Remote . on_all_worker_cores ( fn -&gt; local_worker ( Map . new ( ) , :aggregator ) end ) |&gt; Enum . flat_map ( fn { _node , workers } -&gt; workers end ) |&gt; List . to_tuple ( ) end defhook deliver ( data , _port ) do aggregators = deployment ( ) key = call ( :key , [ data ] ) . result idx = rem ( Murmur . hash_x86_32 ( key ) , tuple_size ( aggregators ) ) worker = elem ( aggregators , idx ) send ( worker , data ) end defhook process ( data , state_map , :aggregator ) do key = call ( :key , [ data ] ) . result state = Map . get ( state_map , key , initial_state ( ) ) res = call ( :react , state , nil , [ data ] ) emit ( res . emit ) Map . put ( state_map , key , res . state ) end end { :module , KeyedState , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 20 , ... &gt;&gt; , { :process , 4 } } This strategy partitions the key of an operation over several workers . When a data record needs to be processed, the key callback of the operation is called, after which the resulting value is used to select a worker to process the data element. Elements with the same key get sent to the same worker. When a worker receives a data element, it calls the react callback of the operation with the correct state. The updated state returned by react is stored inside the worker. The deploy hook is responsible for deploying the operation over the cluster. In this case, this is done by creating several workers, one for every (CPU) core of every node in the cluster. The pids of the spawned workers are converted to a tuple for easy indexing and returned as the result of deploy . This result is stored inside the deployment , which is an immutable data store that can be accessed by all other hooks. The deliver hook is called when a previous node in the workflow emits data. It is responsible for sending the emitted data to a worker to be processed. This is done by obtaining the key for the data element (using the key callback of the operation), and using the resulting key to select a worker. This is done by hashing the key and using the hash to select a worker from the tuple of worker pids (obtained through the deployment() operator). Once a worker is selected, the send operator is used to send the data to the selected worker. The process hook is called when a worker receives a message. It is called with the received message and the current state of the worker. A worker in the KeyedState strategy may store the state of several keys. Therefore, the state of the worker is a map, which associates a key with its state. Inside the process hook, the state of the appropriate key is extracted from the map, after which react is called with this state and the received data. The data emitted by react is emitted by the strategy (potentially calling the deliver hook of the strategies of downstream nodes), and the updated state is stored inside the worker's state. The result of the process hook is stored as the new state of the worker. We define a single additional strategy, called Sedentary which we use to distribute the Show operation defined above. This strategy executes all oeprations in a single worker. defstrategy Sedentary do defhook deploy do config = call_if_exists ( :conf , [ args ( ) ] ) . result ref = remote_worker ( initial_state ( ) , :worker ) { config , ref } end defhook deliver ( data , _port ) do { _ , worker } = deployment ( ) send ( worker , data ) end defhook process ( msg , state , _ ) do { conf , _ } = deployment ( ) res = call ( :react , state , conf , [ msg ] ) emit ( res . emit ) res . state end end { :module , Sedentary , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 16 , ... &gt;&gt; , { :process , 4 } } Inside the deploy hook, a single worker is created. Additionally, the conf callback is called to enable the operation to set up its configuration data. In the case of the Show operation, this configuration will contain the frame that will be used to show the current word counts. A reference to the worker and the created configuration are returned to be stored inside the deployment data. Inside the deliver hook, the reference to the worker is retrieved from the deployment data after which the data to be sent is sent to the worker. Upon receiving the data, the worker will call the react callback of the operation to process the data. The new state and emitted data returned by the operation are stored inside the worker and emitted, respectively.","ref":"language_concepts.html#strategies","title":"Language Concepts - Strategies","type":"extras"},{"doc":"frame = Kino.Frame . new ( ) ref = workflow do stream_source ( phrase_stream ) ~&gt; flat_map ( &amp; String . split / 1 ) ~&gt; node ( Count , with : KeyedState ) ~&gt; node ( Show , with : Sedentary , args : frame ) end |&gt; Skitter.Runtime . deploy ( ) # Reference &lt; 0.2711774296 . 1163657217.41538 &gt; Skitter.Runtime . stop ( ref ) :ok","ref":"language_concepts.html#executable-example","title":"Language Concepts - Executable Example","type":"extras"},{"doc":"This page details how a Skitter system can be deployed over one or many machines.","ref":"deployment.html","title":"Deployment","type":"extras"},{"doc":"Elixir offers several ways to run applications: during development, developers compile and run their applications using mix , the elixir build tool and iex , the interactive elixir shell. In order to run an application in production, releases ( mix release ) are used. Skitter follows this convention. mix and iex are used to run an application during development, while releases are built and used to deploy the application over a cluster.","ref":"deployment.html#elixir-mix-and-releases","title":"Deployment - Elixir, mix and releases","type":"extras"},{"doc":"While writing an application, developers typically use iex to experiment with their application. Calling iex -S mix starts the interactive elixir shell and loads the current project into iex , enabling users to access the modules of their project and its dependencies. mix run can be used to start the project without starting an interactive shell. When a Skitter application (i.e. an application which uses Skitter as a dependency) is started using iex -S mix or mix run , Skitter will start in local mode. In this mode, the Skitter runtime system will act as both a master and a worker runtime, enabling developers to experiment with their code in a single iex or mix session. It is also possible to set up a local distributed environment for experimentation. This is done by starting several Skitter runtimes; one of these should be used as the master node, while other should be used as worker nodes. mix skitter.master (or iex -S mix skitter.master ) can be used to start a Skitter master runtime, while mix skitter.worker (or iex -S mix skitter.worker ) can be used to start a worker runtime. In order to connect these runtimes to each other, the right --sname flags need to be passed. Please refer to the mix skitter.worker and mix skitter.master documentation for more information.","ref":"deployment.html#iex-and-mix-during-development","title":"Deployment - iex and mix during development","type":"extras"},{"doc":"In order to deploy a Skitter over a cluster releases ( mix release ) are used. This is done for several reasons: Releases are self-contained. This makes it easier to deploy an application along with the Skitter runtime and its dependencies over a cluster. Releases are somewhat optimized: unused modules are pruned and modules are preload when the erlang vm is started. Releases built with Skitter.Release.step/1 include Skitter-specific configuration and scripts used to facilitate the distribution of a Skitter application over a cluster. In order to enjoy this last benefit, Skitter should be able to customize the generated release, this is done by adding Skitter.Release.step/1 to the :steps used to build a release. This is the case when your Skitter project was created with mix skitter.new . Please refer to the Skitter.Release module documentation for information on how to enable this if this is not the case. Furthermore, releases should be built in :prod mode. Once again, this is already the case when your project was created with mix skitter.new . The skitter deploy script Releases customized by Skitter.Release.step/1 include a skitter script in the &lt;path_to_release&gt;/bin/ directory. This script can be used to start a standalone Skitter runtime or to deploy various Skitter runtimes over a cluster. The following commands are supported: Command Shorthand Description deploy d Deploy a Skitter system over a set of nodes local l Manage a local Skitter runtime worker w Manage a Skitter worker runtime master m Manage a Skitter master runtime help h Get help for a given command --application-version -a the version of the release application --skitter-version -v Get the version of skitter included with this release Please run &lt;path_to_release&gt;/bin/skitter help for more information. Deploying an application over a cluster The deploy mode of the Skitter deploy script can be used to deploy an application over a cluster. At its simplest, the script can be called as follows: $ &lt;path_to_release&gt;/bin/skitter deploy &lt;worker_host_1&gt; &lt;worker_host_2&gt; … &lt;worker_host_n&gt; This will spawn a Skitter worker runtime on each of the provided hosts, after which a master is spawned on the local node. The master will connect to the spawned workers. When the master quits, all the workers will quit as well. If any of the workers cannot be spawned, the deploy script stops the created workers and exits with an error. The deploy script makes the following assumptions: The worker hosts are reachable over ssh without the need for a password The release is available at the same location on all worker nodes. By default, it is assumed this location is the same as the directory from which the release was started. When this is not the case, the --working-dir option can be used. Use skitter help deploy for more information. Starting a workflow The skitter deploy script does not deploy any workflows over the cluster by default, it only spawns master and worker runtimes and connects them together. In order to start a workflow, a few options are available (ordered from most to least preferable): Setting the deploy: key of the Skitter application environment to a 0-arity function. The workflow returned by calling this function will be deployed over the cluster by Skitter. This option is automatically set in config/config.exs if mix skitter.new was used to create the application. Passing the --deploy &lt;expression&gt; flag to the deploy script. This will cause Skitter to deploy the workflow returned by evaluating &lt;expression&gt; over the cluster. Using --mode start_iex to start an interactive shell on the master node, which can be used to call Skitter.Runtime.deploy/1 .","ref":"deployment.html#releases","title":"Deployment - Releases","type":"extras"},{"doc":"This page details how the Skitter runtime can be configured. Skitter is configured through its Application environment. Elixir enables developers to customize this environment at compile time through the use of the config/config.exs file. This environment can also be configured before the application is started by using the config/runtime.exs file. Both files are described in the Config documentation; additional information can be found in the mix release documentation. Concretely this means that you can use both config/config.exs and config/release.exs to configure the Skitter runtime system. Besides this, the skitter tasks, mix skitter.worker and mix skitter.master accept command line arguments (described in their documentation) which further configure Skitter. Similarly, skitter releases started through the skitter script also accept command line arguments which customize the Skitter runtime system.","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"A Skitter runtime is always started in a mode . This mode determines the role of the Skitter runtime in a cluster environment. The following modes are supported: :worker : This runtime will perform computations for a master node. :master : This runtime is responsible for coordinating the various workers in the cluster. :local : This runtime acts as both a worker and a master runtime at the same time. This is used for developing Skitter applications. When no mode is specified, a :local runtime is started. The mode a Skitter runtime is in effects the configuration options it accepts. For instance, a worker runtime may be configured with the name of a single master runtime, while a master runtime is configured with the name of various workers. Any configuration present in the application environment that does not belong to the current mode is ignored. The various utilities which start a Skitter runtime automatically set the mode of the runtime. Therefore, you should not set the mode yourself. The following table shows how to start all types of runtimes based on how you are starting the Elixir system. Mode Using iex Using mix Using releases :local iex -S mix mix run skitter local :worker iex -S mix skitter.worker mix skitter.worker skitter worker :master iex -S mix skitter.master mix skitter.master skitter master","ref":"configuration.html#modes","title":"Configuration - Modes","type":"extras"},{"doc":":deploy Used in :local and :master mode. This key should be set to a 0-arity function which should return a Skitter.Workflow.t/0 . This workflow will be deployed after the Skitter runtime has started. When using releases, a string can be passed to the --deploy flag. This string will be evaluated (using Code.eval_string/3 ). The resulting value should be a workflow, which will be deployed after the Skitter runtime has started. When using mix , the --deploy flag can be used to pass a string to mix skitter.master , which will be used in the same way. Skitter logs various messages to Logger . These cannot be disabled through Skitter itself, however, the Logger can be configured to ignore Skitter messages or to prune them at compile time. A Skitter release logs its log messages to the console logger and to a file ( logger/&lt;node_name&gt;.log ). The settings passed to this file will mirror the settings of the console logger. Logging to this file may be disabled by passing the --no-log option to skitter deploy , skitter master , skitter worker or skitter local . :banner : Determines if the ⬡⬢⬡⬢ Skitter &lt;version&gt; (&lt;mode&gt;) banner is printed when the runtime is started inside iex , defaults to true for non release versions. :telemetry : Skitter can optionally emit telemetry events through the use of the telemetry package. This option determines whether these events are emitted or not. If this option is set to false (the default), all telemetry code is purged at compile time. Therefore, this option can not be adjusted after compile time. Note that Skitter does not register any handlers for the emitted telemetry data. An overview of the events emitted by Skitter can be found on the telemetry page .","ref":"configuration.html#shared-configuration","title":"Configuration - Shared Configuration","type":"extras"},{"doc":":workers : A list of workers to which the master will attempt to connect. If connecting to any of these workers fail, the master will shut down with an error. When using mix skitter.master , the worker names can be provided as arguments to the mix task. When using releases, the worker names can be provided as arguments to the script. The worker names may also be passed to skitter deploy . :shutdown_with_workers : Determines if the master should shut down when any worker it is connected to shuts down. Defaults to false. mix skitter.worker , skitter master and skitter deploy accept a --shutdown-with-workers flag which enables this behaviour.","ref":"configuration.html#master-configuration","title":"Configuration - Master Configuration","type":"extras"},{"doc":":master : A master to connect to. After starting, the worker will attempt to connect to the master node. If the connection fails, the worker will log a warning but stays alive. :shutdown_with_master : Determines if the worker should shut down when the master it is connected to shuts down. Defaults to true. mix skitter.worker , skitter worker and skitter deploy accept a --no-shutdown-with-master flag which disables this behaviour. :tags : A list of t:Skitter.Nodes.tag/0 which will be added to the worker. mix skitter.worker and skitter worker accept a --tag flag which can be used to add tags to a worker. skitter deploy uses a special notation for worker names, which can be used to add tags to workers.","ref":"configuration.html#worker-configuration","title":"Configuration - Worker Configuration","type":"extras"},{"doc":"This page details the telemetry events emitted by Skitter. This page is only relevant for those who wish to intercept the telemetry events produced by Skitter. It is not relevant if you wish to write and deploy a Skitter application. Skitter emits various telemetry events which can be used to introspect the current state of the runtime system. This page details the various events produced by the Skitter runtime system, along with the meta-information passed with these events. Note that these events are only produced when telemetry is set to true in the Skitter application environment.","ref":"telemetry.html","title":"Telemetry","type":"extras"},{"doc":"Telemetry events emitted by Skitter include a lot of information which may be quite large. For instance, many events include a Skitter.Strategy.context/0 struct, which contains a reference to the deployment data, which may be quite large. Developers who write event handlers which forward events to other processes should keep this in mind and only forward the meta information they require. This is especially relevant when data may be sent across the network.","ref":"telemetry.html#writing-telemetry-handlers","title":"Telemetry - Writing telemetry handlers","type":"extras"},{"doc":"Wrapped Events The events described in this section are wrapped in a call to :telemetry.span/3 . This means that a :start , :stop , and :exception handler may be defined for each of these events. For instance, to handle the [:skitter, :foo] event, handlers for [:skitter, :foo, :start] , [:skitter, :foo, :stop] and [:skitter, :foo, :exception] may need to be defined. Please refer to the :telemetry.span/3 documentation for more information. The listed fields are added to both :start and :stop events. Furthermore, a :result field is added to the meta-information of every :stop event, which contains the result of the wrapped code. Hooks [:skitter, :hook, :deploy] : Emitted when the Skitter.Strategy.Operation.deploy/1 hook of a strategy is called. :context : The context passed to Skitter.Strategy.Operation.deploy/1 :result (only for the :stop event): the return value of the hook. This data will be stored inside the strategy's deployment. [:skitter, :hook, deliver] : Emitted when the deliver hook of a strategy is :context , :data , :port : the arguments passed to Skitter.Strategy.Operation.deliver/3 . :pid : The pid/0 of the process calling the hook. Note that this hook is called from within a worker of the strategy emitting the data, so this pid will not refer to a worker of the operation which should receive the data. Instead, it will refer to a worker of its predecessor. :result (only for the :stop event). The result of the Skitter.Strategy.Operation.deliver/3 hook is not used by the runtime system, so you should not use this. [:skitter, :hook, process] : Emitted when the Skitter.Strategy.Operation.process/4 hook of a strategy is called. :context , :message , :state , :tag : the arguments passed to Skitter.Strategy.Operation.process/4 . :pid : The pid/0 of the worker calling the hook. :result (only for the :stop event): the return value of the hook. This data will be used as the new state of the worker which called the hook. Operation Callbacks [:skitter, :operation, :call] : Emitted when an operation callback is called. :pid : The pid/0 of the worker calling the callback. :operation , :name , :state , :config , :args : The arguments passed Skitter.Operation.call/5 . Unwrapped Events The events described in this section are not wrapped and are emitted by :telemetry.execute/3 . Runtime [:skitter, :worker, :init] : Emitted when a new worker is initialized. Note that, when a workflow is deployed, the workers are only initialized after the deploy hook of each node in the workflow is called. context : The context the worker was deployed with. state : The initial state of the worker. tag : The worker Skitter.Worker.tag/0 pid : The pid/0 of the worker. Uniquely identifies the worker. [:skitter, :worker, :send] : Emitted when a message is sent using Skitter.Worker.send/2 . :from : The pid/0 of the worker sending the message. :to : The pid/0 of the worker receiving the message. :message : The message being sent. [:skitter, :runtime, :emit] : Emitted when a strategy emits data using Skitter.Strategy.Operation.emit/2 . context : The context of the hook emitting the data. emit : The emitted data: Skitter.Operation.emit/0 . [:skitter, :runtime, :deploy] : Emitted when a workflow is deployed. The event is emitted after everything is ready, but before Skitter.Runtime.deploy/1 returns. ref : A unique reference to the deployed workflow. [:skitter, :runtime, :stop] : Emitted when a deployed workflow is stopped using Skitter.Runtime.stop/1 . The event is emitted before any workers are stopped. Telemetry events for ref received after this event should be ignored, as no guarantees are made about the internal consistency of the workflow. ref : The reference of the deployed workflow. Remote [:skitter, :remote, :up, :worker] : Emitted when a worker runtime is connected to a master runtime. This event can only occur on a skitter runtime in :master mode. remote : The name of the remote runtime we connected to. :tags : The list of worker Skitter.Remote.tag/0 [:skitter, :remote, :down, :worker] : Emitted when we disconnect from a worker. This event can only occur on a skitter runtime in :master mode. remote : The name of the remote runtime we disconnected from. reason : :down or :remove . In the first case, the remote runtime went down, in the second case, the remote runtime was briefly connected to the local runtime, after which it rejected the connection.","ref":"telemetry.html#telemetry-events","title":"Telemetry - Telemetry Events","type":"extras"}]